//+-----------------------------------------------------------------------------------+
//|                                                      Stoch_Power_Hedger_V4.5.mq4  |
//|                                                          David Moser, 20/FEB/2010 |
//|                                                                dmoser71@gmail.com |
//|                                                     Copyright  2009, David Moser |
//|                                                                                   |
//| A special thanks and recognition to Forrest Miller for the original concept,      |
//| Wackena, and Spike for getting SPH V3 code to where it was, and to the            |
//| [MT_E and I] community for all their feedback and support of this project!        |
//|                                                                                   |
//|  forrest@thevision.net  wackena@bogie-enterprises.com                             |
//|  Spike  bulldogge1232000@yahoo.com  Peter Wu  pwu8@san.rr.com                     |
//+-----------------------------------------------------------------------------------+

// Please, do not sell this EA because it's FREE //

//+-----------------------------------------------------------------------------------+
//| Change Log:                                                                       |
//| 20091007 (V4.0_Beta1): added AutoGMT function, reworked trading hours logic, and  |
//| restructured the code base to make it more manageable.  Corrected the prior       |
//| hacks made to the code. Program core completely re-engineered. -David Moser       |
//|                                                                                   |
//| 20091008 (V4.0_Beta1): Removed the following per Spike's request:                 |
//| AllSymbolsProtect, Manual, OrdersTimeAlive, EquityProtection,                     |
//| AccountMoneyProtection, AccountEquityPercentProtection. -David Moser              |
//|                                                                                   |
//| DDControl enhanced to work during backtest or during live trading.                |
//| Trading hours logic revamped, now only one set of trading times based on GMT.     |
//| System auto-detects account type and adjusts risk accordingly. -David Moser       |
//|                                                                                   |
//| 20091015: (V4.0_Beta2): Added special risk management algorithm (mm=2), plus      |
//| added a trade recovery feature that will catch up trades missed during non-trade  |
//| times according to pip spacing rules. Added additional error handling in trade    |
//| opening and closing routines, including checking for sufficient margin to open    |
//| new trades. Fixed Account Sentry Hook so that the EA will close all trades and    |
//| remain disabled. Fixed My Money Profit Target logic. Added a Max DD indicator to  |
//| gauge the amount of draw down per trade sequence if SL is hit. -David Moser       |
//|                                                                                   |
//| 20091016: (V4.0): Removed ExitOnStoch Parameter, added Strategy Parameter to make |
//| it easy to implement new trading strategies.  Made the Lot Size Array sensitive   |
//| to account draw down so that trade sequence sizing is not broken, added globals   |
//| to preserve lot size sequences between restarts of EA.                            |
//|                                                                                   |
//| 20091028: (V4.01): Fixed GMT Offset bug in time management code.  Updated time    |
//| management parameters to indicate that Start/End Times are in GMT.  Chart format  |
//| improved.                                                                         |
//|                                                                                   |
//| 20091104: (V4.2): Fixed problem where the EA would not close out trades on Friday |
//| sometimes.  Also, added a new parameter FridayGMTStopHour which if left on its    |
//| default of -1, does nothing, but if is increased to 0 or higher, will not trade   |
//| on Fridays starting at that hour GMT.  If used with TTMGoFlat, can close all your |
//| positions at the end of each trading week at whatever GMT Hour you specify.       |
//|                                                                                   |
//| 20091109: (V4.2): Fixed problem on 4-digit brokers where sometimes the OrderSend  |
//| & Orderclose functions would fail with invalid prices.                            |
//|                                                                                   |
//| 20091126: (V4.3): Rewrote CloseAllOrders subroutine to address issue where some   |
//| orders will be orphaned when the system needs to close all buy or sell orders.    |
//|                                                                                   |
//| 20091214: (V4.3TB): Corrected error with maxtrades greater then stop loss.        |
//| All trades now use level 1 stop loss and highest level take profit.               |
//|                                                                                   |
//| 20102012: (V4.4): Fixed divide by zero error when MaxTrades=0 and mm=2, removed   |
//| the MagicMigrate extern since no longer needed.  Merged in Tom B & Peter Wu's     |
//| changes and tweaked for proper integration. Merged in Spike's latest set files.   |
//| Updated MaxDDControl/MaxDDPercent control code to use MathAbs.                    |
//|                                                                                   |
//| 20102014: (V4.41): Added functionality for blackout dates - by David Heath        |
//|                                                                                   |
//| 20102020: (V4.5): Removed Limit Orders function.  Fixed EURUSD GoFlat param per   |
//| Spike near the bottom of the program.  Tweaked Blackout hooks to maintain         |
//| existing open positions' TSL's, etc., but to not open any new positions as        |
//| discussed in the MT E&I thread.  Defined EAName at the top to use throughout EA.  |
//|                                                                                   |
//+-----------------------------------------------------------------------------------+

#property copyright "Copyright  2009, David Moser"
#property link      "http://www.ForexMT4.com/mt_yahoo/"
#define EAName      "Assorted"

#import "wininet.dll"
   int InternetOpenA(string param1, int param2, string param3, string param4, int param5);
   int InternetOpenUrlA(int param1, string param2, string param3, int param4, int param5, int param6);
   int InternetReadFile(int param1, string paramp, int param3, int &param4[]);
   int InternetCloseHandle(int param1);
#import

#include <stderror.mqh>
#include <stdlib.mqh>

extern string       INFO45                          = "Assorted";
extern string       InternalInfo1                   = "If you use the INTERNAL Auto Pair Settings";
extern string       InternalInfo2                   = "All inputs below are ignored except the";
extern string       InternalInfo3                   = "GMT inputs, which must be set correctly";
extern bool         USE_INTERNAL_AUTO_PAIR_SETTINGS = false;
extern string       s00                             = "--Set your broker GMT offset below--";
extern bool         UseAutoGMToffset                = false;      // If true, attempt to connect to public time source to detect GMT offset.
extern bool         AutoFallbackOnFail              = true;      // If true, will use the ManualGMToffset value if the EA cannot read from the public time source.
extern int          ManualGMToffset                 = 2;         // Set your broker's GMT Offset here in case AutoGMT fails

extern string       InternalInfo4                   = "If INTERNAL Auto Pair is False, then";
extern string       InternalInfo5                   = "EA will use the following inputs below";

extern string       cs                              = "--Congested Sniper strategy#1--";
extern int          HMAPeriod                       = 20;
extern int          HMAMethod                       = MODE_LWMA;
extern int          LookBack                        = 28;
extern int          Price                           = PRICE_CLOSE;
extern int          SmoothPeriod                    = 10;
extern int          SignalPeriod                    = 10;
extern string       info                            = "--Kama filter with strategy#1 & #3--";
extern int          KamaPrice                       = PRICE_CLOSE;
extern int          KamaPeriod                      =  14;
extern int          FastEndPeriod                   =  2;
extern int          SlowEndPeriod                   =  30;
extern double       Power                           = 2.0;
extern int          Filter                          =  50;
extern int          FilterPeriod                    =  4;
extern double       FilterDifference                =  10;
extern int          STCPeriod                       = 10;
extern int          FastMAPeriod                    = 23;
extern int          SlowMAPeriod                    = 50;
extern string       x                               = "--Pivots also with strategy#1--";
extern bool         midpivots                       = false;
extern bool         Fhr                             = false;
extern bool         daily                           = false;
extern bool         weekly                          = true;
extern bool         monthly                         = false;
extern color        r3color                         = Magenta;
extern int          r3width                         = 1;
extern color        r2color                         = Red;
extern color        r1color                         = Red;
extern color        pcolor                          = Gold;
extern int          pwidth                          = 1;
extern color        s1color                         = DodgerBlue;
extern color        s2color                         = DodgerBlue;
extern color        s3color                         = Aqua;
extern int          s3width                         = 1;
extern int          m5color                         = LightGray;
extern int          m4color                         = LightGray;
extern int          m3color                         = LightGray;
extern int          m2color                         = LightGray;
extern int          m1color                         = LightGray;
extern int          m0color                         = LightGray;

extern string       s01                             = "--ICHIMOKU SETTINGS For Strategy#2--";
extern int          Tenkan                          = 9;
extern int          Kijun                           = 26;
extern int          Senkou                          = 52;
extern int          tf                              = 240;
extern int          tf2                             = 15;

extern string       s04                             = "--TRADE SETTINGS--";
extern string       s04a                            = "#1=pivots2=MTF Ichimoku Cross3=Schaff and Kama with filter";
extern int          Strategy                        = 3;           // #1=pivots2=MTF Ichimoku Cross3=Schaff and Kama with filter
extern double       Lots                            = 0.01;        // We start with this number of lots
extern int          TakeProfit                      = 110;         // Profit Goal in PIPs for the latest order opened
extern double       multiply                        = 1.7; 
extern int          MaxTrades                       = 6;           // Maximum number of orders to open
extern int          Pips                            = 20;          // Distance in Pips from one order to another
extern int          StopLoss                        = 600;         // StopLoss
extern int          TrailingStop                    = 20;          // Pips to trail the StopLoss
extern int          TrailingStep                    = 0;           // Pip interval to increment Trailing StopLoss by each time
extern bool         RecoveryMode                    = false;        // If non-trading hours blocks opening more than 1 market order to maintain
                                                                    // PIP spacing, then open up 2+ orders as needed if true, only 1 if false.
extern string       s05                             = "--MONEY MANAGEMENT--";       
extern string       MM_0                            = "mm=0, risk is ignored, just use Lots parameter";
extern string       MM_1                            = "mm=1, risk is basic multiplier based on account balance";
extern string       MM_2                            = "mm=2, risk is % of account balance to risk per sequence";

extern int          mm                              = 2;
extern string       MyRisk                          = "set risk to use when calculating lot size";
extern double       risk                            = 15;        // risk to calculate the lots size (only if mm is enabled)
extern bool         TradeMicroLots                  = false;        // will auto-detect account types, but override available here

extern string       s06                             = "--MAGIC NUMBERS--";
extern int          MagicNumber                     = 41955;        // Primary Magic number for all orders placed

extern string       s07                             = "--CUTLOSS SETTING--";
extern bool         MyMoneyProfitTarget             = false;
extern double       My_Money_Profit_Target          = 5000;
extern bool         SecureProfitProtection          = false;
extern string       SP45                            = "If profit made is bigger than SecureProfit we close the orders";
extern int          SecureProfit                    =  15;        // If profit made is bigger than SecureProfit we close the orders
extern string       OTP45                           = "Number of orders to trigger SP Protection";
extern int          OrderstoProtect                 = 3;         // Number of orders to enable the account protection

extern string       s08                             = "--TRADING TIME MANAGEMENT--";
extern string       TTM1                            = "Set time frames when new trades can open.";
extern string       TTM2                            = "If Starthour = Stophour, then trade 24/5.";
extern string       TTM3                            = "If TTMGoFlat=true, close all open trades";
extern string       TTM4                            = "when outside trading hours or days.";
extern int          GMTStartHour                    = 0;            // Start trading at 0:00/GMT
extern int          GMTStopHour                     = 0;            // Stop trading at 23:59/GMT
extern bool         TradeOnFriday                   = true;
extern int          FridayGMTStopHour               =  -1;          // If set to 0 or higher, will prevent new trades from opening on Friday starting at that hour GMT.                                                                   // If used in conjunction with TTMGoFlat, will close all trades at the end of the trading week. 
extern bool         TTMGoFlat                       =  false;

extern string       s09                             = "--DRAWDOWN CONTROL TOOL--";
extern string       DDC1                            = "Max DD in money allowed?";
extern bool         MaxDDControl                    = false;
extern double       MaxAllowedDD                    = -1000.0;
extern string       DDC2                            = "Max DD in percentage allowed?";
extern bool         MaxPercentDDControl             = false;
extern double       MaxAllowedPercentDD             = -30.0;

extern string       s10                             = "--DRAWDOWN REPORTING==";
extern bool         ShowDDinfoOnChart               = true;

extern string       s11                             = "--OTHER SETTINGS--";
extern string       reverse45                       = "If true, the decision to go long/short will be reversed";
extern bool         ReverseCondition                = false;       // if one the decision to go long/short will be reversed
color               ArrowsColor                     = Yellow;      // color for the orders arrows

extern string       s12                             = "-- Use this section to exclude trading days";
extern bool         EnableBlackout                  = True;
extern int          StartBlackoutDay                = 20;
extern int          StartBlackoutMonth              = 12;

extern int          StopBlackoutDay                 = 15;
extern int          StopBlackoutMonth               = 01;

  int                 StartBlackout = 0;
  int                 StopBlackout = 0;

// End code added by David Heath

// Program Variables for Time Management
  int                 InternetHandle;
  string              GMTOffsetStatusInfo;
  bool                AutoGMTfailure=false;
  bool                OneTimeInitialize=true;
  bool                EADisabled=false;
  bool                TradingDisabled=false;
  datetime            dtBuyAllowed=0, dtSellAllowed=0; // This is used to control the manual confirmation dialog 

// Program Variables for Order Management
  bool                exitBuy = false, exitSell = false;
  int                 CurrentOpenOrders[2]={0,0};
  int                 MarketOpenOrders[2]={0,0};
  int                 PreviousOpenOrders[2]={0,0};
  datetime            LastOrderOpenTime[2]={0,0};
  double              LastOrderOpenPrice[2]={0,0};
  double              MMProfit[2]={0,0}; // Track MyMoney Profit Target Info
  double              SPProfit[2]={0,0}; // Track Secure Profit Protection Info
  double              sl=0, tp=0, BuyPrice=0, SellPrice=0;
  double              BaseLot=0, myBaseLot=0;
  double              LotSizeArray[100,2]; // Element 99,0 and 99,1 used to hold account balance at start of sequence
                                         // Second dimension *,0 or *,1 is OP_BUY, OP_SELL specification
  int                 mode=0, myOrderTypetmp=0, slippage=50;

// Program Variables for Order Opening
  double Var1,Var2,Var3,Var4,Var5,Var6,Var7,Var8,Var9,Var10,Var12,Var13,Var100,Var55, Var555;
  double Var11,Var22,Var33,Var44,Var44x,Var44y, Var111, Var222, Var333, Var444;
  double Fhr_day_high=0;
  double Fhr_day_low=0;
  double Fhr_yesterday_high=0;
  double Fhr_yesterday_open=0;
  double Fhr_yesterday_low=0;
  double Fhr_yesterday_close=0;
  double Fhr_today_open=0;
  double Fhr_today_high=0;
  double Fhr_today_low=0;
  double Fhr_P=0;
  double Fhr_Q=0;
  double Fhr_R1,Fhr_R2,Fhr_R3;
  double Fhr_M0,Fhr_M1,Fhr_M2,Fhr_M3,Fhr_M4,Fhr_M5;
  double Fhr_S1,Fhr_S2,Fhr_S3;
  double Fhr_nQ=0;
  double Fhr_nD=0;
  double Fhr_D=0;
  double Fhr_rates_d1[2][6];
//---------------------------------
  double D_day_high=0;
  double D_day_low=0;
  double D_yesterday_high=0;
  double D_yesterday_open=0;
  double D_yesterday_low=0;
  double D_yesterday_close=0;
  double D_today_open=0;
  double D_today_high=0;
  double D_today_low=0;
  double D_P=0;
  double D_Q=0;
  double D_R1,D_R2,D_R3;
  double D_M0,D_M1,D_M2,D_M3,D_M4,D_M5;
  double D_S1,D_S2,D_S3;
  double D_nQ=0;
  double D_nD=0;
  double D_D=0;
  double D_rates_d1[2][6];
//---------------------------------
  double W_day_high=0;
  double W_day_low=0;
  double W_yesterday_high=0;
  double W_yesterday_open=0;
  double W_yesterday_low=0;
  double W_yesterday_close=0;
  double W_today_open=0;
  double W_today_high=0;
  double W_today_low=0;
  double W_P=0;
  double W_Q=0;
  double W_R1,W_R2,W_R3;
  double W_M0,W_M1,W_M2,W_M3,W_M4,W_M5;
  double W_S1,W_S2,W_S3;
  double W_nQ=0;
  double W_nD=0;
  double W_D=0;
  double W_rates_d1[2][6];
//---------------------------------
  double M_day_high=0;
  double M_day_low=0;
  double M_yesterday_high=0;
  double M_yesterday_open=0;
  double M_yesterday_low=0;
  double M_yesterday_close=0;
  double M_today_open=0;
  double M_today_high=0;
  double M_today_low=0;
  double M_P=0;
  double M_Q=0;
  double M_R1,M_R2,M_R3;
  double M_M0,M_M1,M_M2,M_M3,M_M4,M_M5;
  double M_S1,M_S2,M_S3;
  double M_nQ=0;
  double M_nD=0;
  double M_D=0;
  double M_rates_d1[2][6];
                    

// Program Variables for Statistical Tracking
  double              MaxDD,MaxPercentDD; 

// General Program Variables
  string              text="", TTstatus = "False", MMPTstatus = "False", SPPstatus = "False", LBOT, LSOT;
  double              ActualRiskPercentS, ActualRiskPercentB;
  bool                result;   
  int                 cnt=0, myDigits;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
  int init()
{
//---- 
  OneTimeInitialize=true;
  EADisabled=false;
  if (EADisabled) return(0); //DM: Need to catch and handle if you set USE_INTERNAL_AUTO_PAIR_SETTINGS to true on unsupported currency
  
  if (false) LogPerformance(); //DM: I put this dummy call here to prevent compilation warnings
  if (!IsDllsAllowed() && UseAutoGMToffset && !IsTesting())
  {
    Comment("Error: Parameter \"AllowDLL Imports\" must be ON.");
    Print("Error: Parameter \"AllowDLL Imports\" must be ON.");
    EADisabled=true;
    Print("EA Disabled due to DLL setting conflict with UseAutoGMTOffset.");
    Sleep(10000);
    return(0);
  }

  while (!IsConnected())
  {
    Comment("Waiting for connection...");
    Sleep(10000);
  }

  myDigits=MarketInfo(Symbol(),MODE_DIGITS);
  int x;

  if(myDigits==2) x= 1;
  if(myDigits==3) x=10;
  if(myDigits==4) x= 1;
  if(myDigits==5) x=10;

  TakeProfit   *= x;
  StopLoss     *= x;
  Pips         *= x;
  TrailingStop *= x;
  TrailingStep *= x;

  // Determine Existing Orders, if any.
  UpdateOrderStatus(true);

  // Set status strings for display on chart
  if (MyMoneyProfitTarget) MMPTstatus = "True";
  if (SecureProfitProtection) SPPstatus = "True";

  // Determine Lot Sizing
  if (IsTesting())
  {
    CalculateLotArray(OP_BUY,0);
    CalculateLotArray(OP_SELL,0);
  }
  else
  {
    ReadLotArray(); // Load LotArray from Globals and/or call for initial calculation as needed
  }
  
//********************************************************************************************
//**************TOM - Simple adjustment to lower maxtrades if set beyond stoploss ************
//**************      Should make sure lot allocation is correct but won't reduce backtests **
  MaxTrades = MathMin(MaxTrades, MathCeil(StopLoss / Pips));
//********************************************************************************************
//********************************************************************************************


//********************************************************************************************
//**************David Heath - Code for blackout dates
StartBlackout = DayNumber(StartBlackoutMonth, StartBlackoutDay);
StopBlackout =  DayNumber(StopBlackoutMonth, StopBlackoutDay);
//********************************************************************************************

   return(0);
}


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//---- 
   if (!IsTesting()) WriteLotArray();
   Print("MaxDD: ",MaxDD);
   Print("MaxPercDD: ",MaxPercentDD); 
   ObjectDelete("Fhr_R1 Label");
   ObjectDelete("Fhr_R1 Line");
   ObjectDelete("Fhr_R2 Label");
   ObjectDelete("Fhr_R2 Line");
   ObjectDelete("Fhr_R3 Label");
   ObjectDelete("Fhr_R3 Line");
   ObjectDelete("Fhr_S1 Label");
   ObjectDelete("Fhr_S1 Line");
   ObjectDelete("Fhr_S2 Label");
   ObjectDelete("Fhr_S2 Line");
   ObjectDelete("Fhr_S3 Label");
   ObjectDelete("Fhr_S3 Line");
   ObjectDelete("Fhr_P Label");
   ObjectDelete("Fhr_P Line");
   ObjectDelete("Fhr_M5 Label");
   ObjectDelete("Fhr_M5 Line");
   ObjectDelete("Fhr_M4 Label");
   ObjectDelete("Fhr_M4 Line");
   ObjectDelete("Fhr_M3 Label");
   ObjectDelete("Fhr_M3 Line");
   ObjectDelete("Fhr_M2 Label");
   ObjectDelete("Fhr_M2 Line");
   ObjectDelete("Fhr_M1 Label");
   ObjectDelete("Fhr_M1 Line");
   ObjectDelete("Fhr_M0 Label");
   ObjectDelete("Fhr_M0 Line");

   ObjectDelete("D_R1 Label");
   ObjectDelete("D_R1 Line");
   ObjectDelete("D_R2 Label");
   ObjectDelete("D_R2 Line");
   ObjectDelete("D_R3 Label");
   ObjectDelete("D_R3 Line");
   ObjectDelete("D_S1 Label");
   ObjectDelete("D_S1 Line");
   ObjectDelete("D_S2 Label");
   ObjectDelete("D_S2 Line");
   ObjectDelete("D_S3 Label");
   ObjectDelete("D_S3 Line");
   ObjectDelete("D_P Label");
   ObjectDelete("D_P Line");
   ObjectDelete("D_M5 Label");
   ObjectDelete("D_M5 Line");
   ObjectDelete("D_M4 Label");
   ObjectDelete("D_M4 Line");
   ObjectDelete("D_M3 Label");
   ObjectDelete("D_M3 Line");
   ObjectDelete("D_M2 Label");
   ObjectDelete("D_M2 Line");
   ObjectDelete("D_M1 Label");
   ObjectDelete("D_M1 Line");
   ObjectDelete("D_M0 Label");
   ObjectDelete("D_M0 Line");
   //--------------------------------------
   ObjectDelete("W_R1 Label");
   ObjectDelete("W_R1 Line");
   ObjectDelete("W_R2 Label");
   ObjectDelete("W_R2 Line");
   ObjectDelete("W_R3 Label");
   ObjectDelete("W_R3 Line");
   ObjectDelete("W_S1 Label");
   ObjectDelete("W_S1 Line");
   ObjectDelete("W_S2 Label");
   ObjectDelete("W_S2 Line");
   ObjectDelete("W_S3 Label");
   ObjectDelete("W_S3 Line");
   ObjectDelete("W_P Label");
   ObjectDelete("W_P Line");
   ObjectDelete("W_M5 Label");
   ObjectDelete("W_M5 Line");
   ObjectDelete("W_M4 Label");
   ObjectDelete("W_M4 Line");
   ObjectDelete("W_M3 Label");
   ObjectDelete("W_M3 Line");
   ObjectDelete("W_M2 Label");
   ObjectDelete("W_M2 Line");
   ObjectDelete("W_M1 Label");
   ObjectDelete("W_M1 Line");
   ObjectDelete("W_M0 Label");
   ObjectDelete("W_M0 Line");
//--------------------------------------
   ObjectDelete("M_R1 Label");
   ObjectDelete("M_R1 Line");
   ObjectDelete("M_R2 Label");
   ObjectDelete("M_R2 Line");
   ObjectDelete("M_R3 Label");
   ObjectDelete("M_R3 Line");
   ObjectDelete("M_S1 Label");
   ObjectDelete("M_S1 Line");
   ObjectDelete("M_S2 Label");
   ObjectDelete("M_S2 Line");
   ObjectDelete("M_S3 Label");
   ObjectDelete("M_S3 Line");
   ObjectDelete("M_P Label");
   ObjectDelete("M_P Line");
   ObjectDelete("M_M5 Label");
   ObjectDelete("M_M5 Line");
   ObjectDelete("M_M4 Label");
   ObjectDelete("M_M4 Line");
   ObjectDelete("M_M3 Label");
   ObjectDelete("M_M3 Line");
   ObjectDelete("M_M2 Label");
   ObjectDelete("M_M2 Line");
   ObjectDelete("M_M1 Label");
   ObjectDelete("M_M1 Line");
   ObjectDelete("M_M0 Label");
   ObjectDelete("M_M0 Line");
   DeleteAllObjects();
//----
   return(0);
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  if (EADisabled)
  {
    if (IsTesting()) Comment("EA Disabled! Check Journal Log for details.\n"+text);
    else Comment("EA Disabled! Check Experts Log for details.\n"+text);
    return(0);
  }
  
  // One-time Initialization of GMT Offset and Time-based variables
  if (OneTimeInitialize)
  {
    while (InitializeTimeVariables() < 0) Sleep(1000);
    return(0);
  }

  //**************ADDED FOR ACCOUNT SENTRY ***************
  
  if (GlobalVariableGet("GV_CloseAllAndHalt") > 0)
  {
    CloseAllOrders(OP_BUY);
    CloseAllOrders(OP_SELL);
    EADisabled = true;
    text="Account Sentry Signaled to Close All and Halt";
    return (0);
  } else
  
  //**************END ACCOUNT SENTRY HOOK ****************
  
  text="";
  TrackDrawDown();
  exitBuy = false; exitSell = false;
  int CloseOutStatus = CloseOutTradesCheck(); // Check to see if we should go flat on long or short positions
  if (CloseOutStatus > 0)                                      // CloseOutTradesCheck also updates profit information
  {
    if (exitBuy)  CloseAllOrders(OP_BUY);
    if (exitSell) CloseAllOrders(OP_SELL);
    if (CloseOutStatus == 2)
    {
      EADisabled = true;
      text="My Money Profit Target Achieved!";
      Print(text);
      return(0);
    }
    if (CloseOutStatus == 3)
    {
      EADisabled = true;
      text="DrawDown Threshold Breached!";
      Print(text);
      return(0);
    }
    
  }
  else // no reason to close out trades and/or disable the EA, so let's continue...
  {
    bool TT = false;
    if (IsTradingTime() && !TradingDisabled)
    {
      TT = true;
      PrepareIndicators(); // Obtain indicator data values
      
      // Check for new entry signals.  myOrderTypetmp = 1 for sell, 2 for buy, 3 for no signal.
      myOrderTypetmp=CheckEntrySignal();

      if (ReverseCondition)
      {
        if (myOrderTypetmp==1) myOrderTypetmp=2;
        else if (myOrderTypetmp==2) myOrderTypetmp=1;
      }

      if (myOrderTypetmp==1 && CurrentOpenOrders[OP_SELL]==0 && IsTradeAllowed() && dtSellAllowed < TimeCurrent())
      {
        Print("Starting New SELL Sequence");
        OpenMarketOrders(myOrderTypetmp); // Pass along the Sell Signal
      }

      if (myOrderTypetmp==2 && CurrentOpenOrders[OP_BUY]==0 && IsTradeAllowed() && dtBuyAllowed < TimeCurrent())
      {
        Print("Starting New BUY Sequence");
        OpenMarketOrders(myOrderTypetmp);  // Pass along the Buy Signal
      }

      if (IsTradeAllowed()) OpenMarketOrders(3); // Called with no signal present and will open new orders in an existing sequence as needed
    }
  }

  // Now execute the following code whenever the EA is active, regardless of trade time restrictions or disabled trading condition
  TSManager(); // Check and maintain trailing stops

  TTstatus = "False";
  if (TT) TTstatus = "True";
  if (SecureProfitProtection && MarketOpenOrders[OP_BUY]>=OrderstoProtect) text=StringConcatenate(text, "\nSecure Profit Protection Active on BUY sequence.");
  if (SecureProfitProtection && MarketOpenOrders[OP_SELL]>=OrderstoProtect) text=StringConcatenate(text, "\nSecure Profit Protection Active on SELL sequence.");
  if (MyMoneyProfitTarget) text=StringConcatenate(text, "\nMy Money Profit Target Progress: ", DoubleToStr(MMProfit[OP_BUY]+MMProfit[OP_SELL],2), " of ", DoubleToStr(My_Money_Profit_Target,2));
  //**************Added/Updated for Black out trading times ******
  if (!BlackoutTime() && myOrderTypetmp!=2 && CurrentOpenOrders[OP_BUY]==0 && MaxTrades>0) text=StringConcatenate(text, "\nWAITING FOR BUY SIGNAL...");
  if (!BlackoutTime() && myOrderTypetmp!=1 && CurrentOpenOrders[OP_SELL]==0 && MaxTrades>0) text=StringConcatenate(text, "\nWAITING FOR SELL SIGNAL...");
  if (BlackoutTime()) text=StringConcatenate(text, "\n*** Black out Trading Day. If you want the EA to trade, Change the dates set Blackout to False ***");
  //******************************************************
  if (LastOrderOpenTime[OP_BUY]==0) LBOT="............................";
  else LBOT=TimeToStr(LastOrderOpenTime[OP_BUY],TIME_DATE|TIME_SECONDS);
  if (LastOrderOpenTime[OP_SELL]==0) LSOT="............................";
  else LSOT=TimeToStr(LastOrderOpenTime[OP_SELL],TIME_DATE|TIME_SECONDS);
  string myComment=StringConcatenate(GMTOffsetStatusInfo,ShowLotSizeSequence(),
  "\nIsTradeTime=",TTstatus,", myOrderTypetmp=",myOrderTypetmp,", SPP Enabled=",SPPstatus,", MMPT Enabled=",MMPTstatus,
  "\nBuy: Last Price=",DoubleToStr(LastOrderOpenPrice[OP_BUY],Digits),", Last Time=",LBOT,", Open Mkt Orders=",MarketOpenOrders[OP_BUY],"/",MaxTrades,", Open Profit=",DoubleToStr(SPProfit[OP_BUY],2),
  "\nSell:  Last Price=",DoubleToStr(LastOrderOpenPrice[OP_SELL],Digits),", Last Time=",LSOT,", Open Mkt Orders=",MarketOpenOrders[OP_SELL],"/",MaxTrades,", Open Profit=",DoubleToStr(SPProfit[OP_SELL],2),
  "\nDay of the Year = ",DayOfYear(),", StartBlackout=", StartBlackout, ", StopBlackout=", StopBlackout, ", Blackout= ", BlackoutTime(),
  text);
  Comment(myComment);

  return(0);
}
//+------------------------------------------------------------------+


int CheckEntrySignal()
// Check for new entry signals.  Return 1 for sell, 2 for buy, 3 for no signal.
{
  int myOrderType = 3;
  
    if (Strategy == 1) 
  {
    if (Var11 < Var111 && Var22 < Var222 && Var33 < Var333 && Var44 < Var44x && Var444 <= Var44y && Var11 <= W_R3 && Var11 >= W_R1 && Var12 < Var13 && Var100 > Var12) 
      myOrderType = 1; // signal a sell
    if (Var11 > Var111 && Var22 > Var222 && Var33 > Var333 && Var44 > Var44x && Var444 >= Var44y && Var11 >= W_S3 && Var11 <= W_S1 && Var12 > Var13 && Var100 < Var12) 
      myOrderType = 2; // signal a buy
  }
  
  if (Strategy == 2) 
  {
    if (Var1 < Var2 && Var3 < Var4 && Var5 >= Var6 && Var7 > Var9 && Var8 > Var10) 
      myOrderType=1; // signal a sell
    if (Var1 > Var2 && Var3 > Var4 && Var5 <= Var6 && Var7 < Var9 && Var8 < Var10) 
      myOrderType=2; // signal a buy
  }
  
  if (Strategy == 3) 
  {
    if (Var12 < Var13 && Var100 < Var12 && Var55 < Var555) 
      myOrderType=1; // signal a sell
    if (Var12 > Var13 && Var100 > Var12 && Var55 > Var555) 
      myOrderType=2; // signal a buy
  }

  return(myOrderType);
}


void PrepareIndicators()
{
  
  Var1   = iCustom(NULL, tf, "Ichimoku",Tenkan,Kijun,Senkou,0,1);
  Var2   = iCustom(NULL, tf, "Ichimoku",Tenkan,Kijun,Senkou,1,1);
  Var3   = iCustom(NULL,tf2, "Ichimoku",Tenkan,Kijun,Senkou,0,1);
  Var4   = iCustom(NULL,tf2, "Ichimoku",Tenkan,Kijun,Senkou,1,1);
  Var5   = iCustom(NULL,tf2, "Ichimoku",Tenkan,Kijun,Senkou,0,2);
  Var6   = iCustom(NULL,tf2, "Ichimoku",Tenkan,Kijun,Senkou,1,2);
  Var7   = iCustom(NULL, tf, "Ichimoku",Tenkan,Kijun,Senkou,4,1);
  Var8   = iCustom(NULL,tf2, "Ichimoku",Tenkan,Kijun,Senkou,4,1);
  Var9   = iClose(NULL,tf,1); 
  Var10  = iClose(NULL,tf2,1);
  Var100 = iClose(NULL,0,1);
  Var11  = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_HIGH,HMAMethod,0,1); 
  Var111 = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_HIGH,HMAMethod,0,2);
  Var22  = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_LOW,HMAMethod,0,1); 
  Var222 = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_LOW,HMAMethod,0,2);
  Var33  = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_MEDIAN,HMAMethod,0,1); 
  Var333 = iCustom(NULL,0,"HMAforEA",HMAPeriod,PRICE_MEDIAN,HMAMethod,0,2);
  Var44  = iCustom(NULL,0,"Congestion index",LookBack,Price,SmoothPeriod,SignalPeriod,0,1);
  Var44x = iCustom(NULL,0,"Congestion index",LookBack,Price,SmoothPeriod,SignalPeriod,1,1);
  Var444 = iCustom(NULL,0,"Congestion index",LookBack,Price,SmoothPeriod,SignalPeriod,0,2);
  Var44y = iCustom(NULL,0,"Congestion index",LookBack,Price,SmoothPeriod,SignalPeriod,1,2);
  Var12  = iCustom(NULL,0,"kama with filter",KamaPrice,KamaPeriod,FastEndPeriod,SlowEndPeriod,Power,Filter,FilterPeriod,FilterDifference,0,1);
  Var13  = iCustom(NULL,0,"kama with filter",KamaPrice,KamaPeriod,FastEndPeriod,SlowEndPeriod,Power,Filter,FilterPeriod,FilterDifference,0,2);
  Var55  = iCustom(NULL,0,"Schaff Trend Cycle nrp",STCPeriod,FastMAPeriod,SlowMAPeriod,0,1);
  Var555 = iCustom(NULL,0,"Schaff Trend Cycle nrp",STCPeriod,FastMAPeriod,SlowMAPeriod,0,2);
  
  D_R1=0; D_R2=0; D_R3=0;
  D_M0=0; D_M1=0; D_M2=0; D_M3=0; D_M4=0; D_M5=0;
  D_S1=0; D_S2=0; D_S3=0;


  W_R1=0; W_R2=0; W_R3=0;
  W_M0=0; W_M1=0; W_M2=0; W_M3=0; W_M4=0; W_M5=0;
  W_S1=0; W_S2=0; W_S3=0;


  M_R1=0; M_R2=0; M_R3=0;
  M_M0=0; M_M1=0; M_M2=0; M_M3=0; M_M4=0; M_M5=0;
  M_S1=0; M_S2=0; M_S3=0;


  Fhr_R1=0; Fhr_R2=0; Fhr_R3=0;
  Fhr_M0=0; Fhr_M1=0; Fhr_M2=0; Fhr_M3=0; Fhr_M4=0; Fhr_M5=0;
  Fhr_S1=0; Fhr_S2=0; Fhr_S3=0;
  
  ArrayCopyRates(Fhr_rates_d1, Symbol(), 240);

   Fhr_yesterday_close = Fhr_rates_d1[1][4];
   Fhr_yesterday_open = Fhr_rates_d1[1][1];
   Fhr_today_open = Fhr_rates_d1[0][1];
   Fhr_yesterday_high = Fhr_rates_d1[1][3];
   Fhr_yesterday_low = Fhr_rates_d1[1][2];
   Fhr_day_high = Fhr_rates_d1[0][3];
   Fhr_day_low = Fhr_rates_d1[0][2];


//---- Calculate Pivots

   Fhr_D = (Fhr_day_high - Fhr_day_low);
   Fhr_Q = (Fhr_yesterday_high - Fhr_yesterday_low);
   Fhr_P = (Fhr_yesterday_high + Fhr_yesterday_low + Fhr_yesterday_close) / 3;
   Fhr_R1 = (2*Fhr_P)-Fhr_yesterday_low;
   Fhr_S1 = (2*Fhr_P)-Fhr_yesterday_high;
   Fhr_R2 = Fhr_P+(Fhr_yesterday_high - Fhr_yesterday_low);
   Fhr_S2 = Fhr_P-(Fhr_yesterday_high - Fhr_yesterday_low);

   
   Fhr_R3 = (2*Fhr_P)+(Fhr_yesterday_high-(2*Fhr_yesterday_low));
   Fhr_M5 = (Fhr_R2+Fhr_R3)/2;
   Fhr_M4 = (Fhr_R1+Fhr_R2)/2;
   Fhr_M3 = (Fhr_P+Fhr_R1)/2;
   Fhr_M2 = (Fhr_P+Fhr_S1)/2;
   Fhr_M1 = (Fhr_S1+Fhr_S2)/2;
   Fhr_S3 = (2*Fhr_P)-((2* Fhr_yesterday_high)-Fhr_yesterday_low);
   Fhr_M0 = (Fhr_S2+Fhr_S3)/2;

   if (Fhr_Q > 5)
   {
   Fhr_nQ = Fhr_Q;
   }
   else
   {
   Fhr_nQ = Fhr_Q*10000;
   }

   if (Fhr_D > 5)
   {
   Fhr_nD = Fhr_D;
   }
   else
   {
   Fhr_nD = Fhr_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   Fhr_nQ=Fhr_nQ/100;
   Fhr_nD=Fhr_nD/100;     
   }
//----------------------------------------------------------------------------- Get DAY ---------------
   ArrayCopyRates(D_rates_d1, Symbol(), 1440);

   D_yesterday_close = D_rates_d1[1][4];
   D_yesterday_open = D_rates_d1[1][1];
   D_today_open = D_rates_d1[0][1];
   D_yesterday_high = D_rates_d1[1][3];
   D_yesterday_low = D_rates_d1[1][2];
   D_day_high = D_rates_d1[0][3];
   D_day_low = D_rates_d1[0][2];

   D_D = (D_day_high - D_day_low);
   D_Q = (D_yesterday_high - D_yesterday_low);
   D_P = (D_yesterday_high + D_yesterday_low + D_yesterday_close) / 3;
   D_R1 = (2*D_P)-D_yesterday_low;
   D_S1 = (2*D_P)-D_yesterday_high;
   D_R2 = D_P+(D_yesterday_high - D_yesterday_low);
   D_S2 = D_P-(D_yesterday_high - D_yesterday_low);

   
   D_R3 = (2*D_P)+(D_yesterday_high-(2*D_yesterday_low));
   D_M5 = (D_R2+D_R3)/2;
   D_M4 = (D_R1+D_R2)/2;
   D_M3 = (D_P+D_R1)/2;
   D_M2 = (D_P+D_S1)/2;
   D_M1 = (D_S1+D_S2)/2;
   D_S3 = (2*D_P)-((2* D_yesterday_high)-D_yesterday_low);
   
   D_M0 = (D_S2+D_S3)/2;

   if (D_Q > 5)
   {
   D_nQ = D_Q;
   }
   else
   {
   D_nQ = D_Q*10000;
   }

   if (D_D > 5)
   {
   D_nD = D_D;
   }
   else
   {
   D_nD = D_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   D_nQ=D_nQ/100;
   D_nD=D_nD/100;     
   }
//----------------------------------------------------------------------------- Weekly ---------------
   ArrayCopyRates(W_rates_d1, Symbol(), 10080);

   W_yesterday_close = W_rates_d1[1][4];
   W_yesterday_open = W_rates_d1[1][1];
   W_today_open = W_rates_d1[0][1];
   W_yesterday_high = W_rates_d1[1][3];
   W_yesterday_low = W_rates_d1[1][2];
   W_day_high = W_rates_d1[0][3];
   W_day_low = W_rates_d1[0][2];

   W_D = (W_day_high - W_day_low);
   W_Q = (W_yesterday_high - W_yesterday_low);
   W_P = (W_yesterday_high + W_yesterday_low + W_yesterday_close) / 3;
   W_R1 = (2*W_P)-W_yesterday_low;
   W_S1 = (2*W_P)-W_yesterday_high;
   W_R2 = W_P+(W_yesterday_high - W_yesterday_low);
   W_S2 = W_P-(W_yesterday_high - W_yesterday_low);
   
   W_R3 = (2*W_P)+(W_yesterday_high-(2*W_yesterday_low));
   W_M5 = (W_R2+W_R3)/2;
   W_M4 = (W_R1+W_R2)/2;
   W_M3 = (W_P+W_R1)/2;
   W_M2 = (W_P+W_S1)/2;
   W_M1 = (W_S1+W_S2)/2;
   W_S3 = (2*W_P)-((2* W_yesterday_high)-W_yesterday_low);
   W_M0 = (W_S2+W_S3)/2;

   if (W_Q > 5)
   {
   W_nQ = W_Q;
   }
   else
   {
   W_nQ = W_Q*10000;
   }

   if (W_D > 5)
   {
   W_nD = W_D;
   }
   else
   {
   W_nD = W_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   W_nQ=W_nQ/100;
   W_nD=W_nD/100;     
   }
//-------------------------------------------------------------MONTHLY-------------------------------------------
   ArrayCopyRates(M_rates_d1, Symbol(), 43200);

   M_yesterday_close = M_rates_d1[1][4];
   M_yesterday_open = M_rates_d1[1][1];
   M_today_open = M_rates_d1[0][1];
   M_yesterday_high = M_rates_d1[1][3];
   M_yesterday_low = M_rates_d1[1][2];
   M_day_high = M_rates_d1[0][3];
   M_day_low = M_rates_d1[0][2];

   M_D = (M_day_high - M_day_low);
   M_Q = (M_yesterday_high - M_yesterday_low);
   M_P = (M_yesterday_high + M_yesterday_low + M_yesterday_close) / 3;
   M_R1 = (2*M_P)-M_yesterday_low;
   M_S1 = (2*M_P)-M_yesterday_high;
   M_R2 = M_P+(M_yesterday_high - M_yesterday_low);
   M_S2 = M_P-(M_yesterday_high - M_yesterday_low);

   M_R3 = (2*M_P)+(M_yesterday_high-(2*M_yesterday_low));
   M_M5 = (M_R2+M_R3)/2;
   M_M4 = (M_R1+M_R2)/2;
   M_M3 = (M_P+M_R1)/2;
   M_M2 = (M_P+M_S1)/2;
   M_M1 = (M_S1+M_S2)/2;
   M_S3 = (2*M_P)-((2* M_yesterday_high)-M_yesterday_low);

   M_M0 = (M_S2+M_S3)/2;

   if (M_Q > 5)
   {
   M_nQ = M_Q;
   }
   else
   {
   M_nQ = M_Q*10000;
   }

   if (M_D > 5)
   {
   M_nD = M_D;
   }
   else
   {
      M_nD = M_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   M_nQ=M_nQ/100;
   M_nD=M_nD/100;     
   }
   
   if (Fhr==true)
   {
   if(ObjectFind("Fhr_R1 label") != 0)
   {
      ObjectCreate("Fhr_R1 label", OBJ_TEXT, 0, Time[0], Fhr_R1);
      ObjectSetText("Fhr_R1 label", "Fhr_R1 " +DoubleToStr(Fhr_R1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("Fhr_R1 label", 0, Time[0], Fhr_R1);
   }

   if(ObjectFind("Fhr_R2 label") != 0)
   {
      ObjectCreate("Fhr_R2 label", OBJ_TEXT, 0, Time[20], Fhr_R2);
      ObjectSetText("Fhr_R2 label", "Fhr_R2 " +DoubleToStr(Fhr_R2,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_R2 label", 0, Time[0], Fhr_R2);
   }

   if(ObjectFind("Fhr_R3 label") != 0)
   {
      ObjectCreate("Fhr_R3 label", OBJ_TEXT, 0, Time[20], Fhr_R3);
      ObjectSetText("Fhr_R3 label", "Fhr_R3 " +DoubleToStr(Fhr_R3,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_R3 label", 0, Time[0], Fhr_R3);
   }

   if(ObjectFind("Fhr_P label") != 0)
   {
      ObjectCreate("Fhr_P label", OBJ_TEXT, 0, Time[0], Fhr_P);
      ObjectSetText("Fhr_P label", "Fhr_Pivot " +DoubleToStr(Fhr_P,4), 8, "Arial",EMPTY);
   }
   else
   {
      ObjectMove("Fhr_P label", 0, Time[0], Fhr_P);
   }

   if(ObjectFind("Fhr_S1 label") != 0)
   {
      ObjectCreate("Fhr_S1 label", OBJ_TEXT, 0, Time[0], Fhr_S1);
      ObjectSetText("Fhr_S1 label", "Fhr_S1 " +DoubleToStr(Fhr_S1,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S1 label", 0, Time[0], Fhr_S1);
   }

   if(ObjectFind("Fhr_S2 label") != 0)
   {
      ObjectCreate("Fhr_S2 label", OBJ_TEXT, 0, Time[20], Fhr_S2);
      ObjectSetText("Fhr_S2 label", "Fhr_S2 " +DoubleToStr(Fhr_S2,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S2 label", 0, Time[0], Fhr_S2);
   }

   if(ObjectFind("Fhr_S3 label") != 0)
   {
      ObjectCreate("Fhr_S3 label", OBJ_TEXT, 0, Time[20], Fhr_S3);
      ObjectSetText("Fhr_S3 label", "Fhr_S3 " +DoubleToStr(Fhr_S3,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S3 label", 0, Time[0], Fhr_S3);
   }

//--- Draw Pivot lines on chart
   if(ObjectFind("Fhr_S1 line") != 0)
   {
      ObjectCreate("Fhr_S1 line", OBJ_HLINE, 0, Time[0], Fhr_S1);
      ObjectSet("Fhr_S1 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_S1 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_S1 line", OBJPROP_COLOR, s1color);
   }
   else
   {
      ObjectMove("Fhr_S1 line", 0, Time[40], Fhr_S1);
   }

   if(ObjectFind("Fhr_S2 line") != 0)
   {
      ObjectCreate("Fhr_S2 line", OBJ_HLINE, 0, Time[40], Fhr_S2, Time[0], Fhr_S2);
      ObjectSet("Fhr_S2 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_S2 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_S2 line", OBJPROP_COLOR, s2color);
   }
   else
   {
      ObjectMove("Fhr_S2 line", 0, Time[40], Fhr_S2);
   }

   if(ObjectFind("Fhr_S3 line") != 0)
   {
      ObjectCreate("Fhr_S3 line", OBJ_HLINE, 0, Time[40], Fhr_S3, Time[0], Fhr_S3);
      ObjectSet("Fhr_S3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_S3 line", OBJPROP_WIDTH, s3width);
      ObjectSet("Fhr_S3 line", OBJPROP_COLOR, s3color);
   }
   else
   {
     ObjectMove("Fhr_S3 line", 0, Time[40], Fhr_S3);
   }

   if(ObjectFind("Fhr_P line") != 0)
   {
      ObjectCreate("Fhr_P line", OBJ_HLINE, 0, Time[40], Fhr_P, Time[0], Fhr_P);
      ObjectSet("Fhr_P line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_P line", OBJPROP_WIDTH,pwidth);
      ObjectSet("Fhr_P line", OBJPROP_COLOR, pcolor);
   }
   else
   {
      ObjectMove("Fhr_P line", 0, Time[40], Fhr_P);
   }

   if(ObjectFind("Fhr_R1 line") != 0)
   {
      ObjectCreate("Fhr_R1 line", OBJ_HLINE, 0, Time[40], Fhr_R1, Time[0], Fhr_R1);
      ObjectSet("Fhr_R1 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_R1 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_R1 line", OBJPROP_COLOR, r1color);
   }
   else
   {
      ObjectMove("Fhr_R1 line", 0, Time[40], Fhr_R1);
   }

   if(ObjectFind("Fhr_R2 line") != 0)
   {
      ObjectCreate("Fhr_R2 line", OBJ_HLINE, 0, Time[0], Fhr_R2);//, Time[0], Fhr_R2);
      ObjectSet("Fhr_R2 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_R2 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_R2 line", OBJPROP_COLOR, r2color);
   }
   else
   {
      ObjectMove("Fhr_R2 line", 0, Time[40], Fhr_R2);
   }

   if(ObjectFind("Fhr_R3 line") != 0)
   {
      ObjectCreate("Fhr_R3 line", OBJ_HLINE, 0, Time[40], Fhr_R3, Time[0], Fhr_R3);
      ObjectSet("Fhr_R3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_R3 line", OBJPROP_WIDTH, r3width);
      ObjectSet("Fhr_R3 line", OBJPROP_COLOR, r3color);
   }
   else
   {
      ObjectMove("Fhr_R3 line", 0, Time[40], Fhr_R3);
   }
} 
//---- End of 4 Hour Pivot Line Draw


//------ Midpoints Pivots

if (Fhr == true && midpivots==true)
{

if(ObjectFind("Fhr_M5 label") != 0)
{
ObjectCreate("Fhr_M5 label", OBJ_TEXT, 0, Time[20], Fhr_M5);
ObjectSetText("Fhr_M5 label", " Fhr_M5 " +DoubleToStr(Fhr_M5,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M5 label", 0, Time[0], Fhr_M5);
}

if(ObjectFind("Fhr_M4 label") != 0)
{
ObjectCreate("Fhr_M4 label", OBJ_TEXT, 0, Time[20], Fhr_M4);
ObjectSetText("Fhr_M4 label", "Fhr_M4 " +DoubleToStr(Fhr_M4,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M4 label", 0, Time[0], Fhr_M4);
}

if(ObjectFind("Fhr_M3 label") != 0)
{
ObjectCreate("Fhr_M3 label", OBJ_TEXT, 0, Time[20], Fhr_M3);
ObjectSetText("Fhr_M3 label", "Fhr_M3 " +DoubleToStr(Fhr_M3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M3 label", 0, Time[0], Fhr_M3);
}

if(ObjectFind("Fhr_M2 label") != 0)
{
ObjectCreate("Fhr_M2 label", OBJ_TEXT, 0, Time[20], Fhr_M2);
ObjectSetText("Fhr_M2 label", "Fhr_M2 " +DoubleToStr(Fhr_M2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M2 label", 0, Time[0], Fhr_M2);
}

if(ObjectFind("Fhr_M1 label") != 0)
{
ObjectCreate("Fhr_M1 label", OBJ_TEXT, 0, Time[20], Fhr_M1);
ObjectSetText("Fhr_M1 label", "Fhr_M1 " +DoubleToStr(Fhr_M1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M1 label", 0, Time[0], Fhr_M1);
}

if(ObjectFind("Fhr_M0 label") != 0)
{
ObjectCreate("Fhr_M0 label", OBJ_TEXT, 0, Time[20], Fhr_M0);
ObjectSetText("Fhr_M0 label", "Fhr_M0 " +DoubleToStr(Fhr_M0,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("Fhr_M0 label", 0, Time[0], Fhr_M0);
}

//---- Draw Midpoint Pivots on Chart
if(ObjectFind("Fhr_M5 line") != 0)
{
ObjectCreate("Fhr_M5 line", OBJ_HLINE, 0, Time[0], Fhr_M5, Time[0], Fhr_M5);
ObjectSet("Fhr_M5 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Fhr_M5 line", OBJPROP_WIDTH, 1);
ObjectSet("Fhr_M5 line", OBJPROP_COLOR, m5color);
}
else
{
ObjectMove("Fhr_M5 line", 0, Time[40], Fhr_M5);
}

if(ObjectFind("Fhr_M4 line") != 0)
{
ObjectCreate("Fhr_M4 line", OBJ_HLINE, 0, Time[40], Fhr_M4, Time[0], Fhr_M4);
ObjectSet("Fhr_M4 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Fhr_M4 line", OBJPROP_WIDTH, 1);
ObjectSet("Fhr_M4 line", OBJPROP_COLOR, m4color);
}
else
{
ObjectMove("Fhr_M4 line", 0, Time[40], Fhr_M4);
}

if(ObjectFind("Fhr_M3 line") != 0)
{
ObjectCreate("Fhr_M3 line", OBJ_HLINE, 0, Time[0], Fhr_M3, Time[0], Fhr_M3);
ObjectSet("Fhr_M3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Fhr_M3 line", OBJPROP_WIDTH, 1);
ObjectSet("Fhr_M3 line", OBJPROP_COLOR, m3color);
}
else
{
ObjectMove("Fhr_M3 line", 0, Time[40], Fhr_M3);
}

if(ObjectFind("Fhr_M2 line") != 0)
{
ObjectCreate("Fhr_M2 line", OBJ_HLINE, 0, Time[40], Fhr_M2);
ObjectSet("Fhr_M2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Fhr_M2 line", OBJPROP_WIDTH, 1);
ObjectSet("Fhr_M2 line", OBJPROP_COLOR, m2color);
}
else
{
ObjectMove("Fhr_M2 line", 0, Time[40], Fhr_M2);
}

if(ObjectFind("Fhr_M1 line") != 0)
   {
      ObjectCreate("Fhr_M1 line", OBJ_HLINE, 0, Time[40], Fhr_M1);
      ObjectSet("Fhr_M1 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_M1 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_M1 line", OBJPROP_COLOR, m1color);
   }
   else
   {
   ObjectMove("Fhr_M1 line", 0, Time[40], Fhr_M1);
   }

   if(ObjectFind("Fhr_M0 line") != 0)
   {
      ObjectCreate("Fhr_M0 line", OBJ_HLINE, 0, Time[40], Fhr_M0);
      ObjectSet("Fhr_M0 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_M0 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_M0 line", OBJPROP_COLOR, m0color);
   }
      else
   {
      ObjectMove("Fhr_M0 line", 0, Time[40], Fhr_M0);
   }

}
//--------------------------------------------------------End of 4 hour 
//----------------------------------------------------------------------------DAILY Pivot Lines --------------------
if (daily==true)
{
if(ObjectFind("    D_R1 label") != 0)
{
ObjectCreate("     D_R1 label", OBJ_TEXT, 0, Time[0], D_R1);
ObjectSetText("D_R1 label", "                              D_R1 " +DoubleToStr(D_R1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("     D_R1 label", 0, Time[0], D_R1);
}

if(ObjectFind("D_R2 label") != 0)
{
ObjectCreate("D_R2 label", OBJ_TEXT, 0, Time[20], D_R2);
ObjectSetText("D_R2 label", "                              D_R2 " +DoubleToStr(D_R2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_R2 label", 0, Time[0], D_R2);
}

if(ObjectFind("D_R3 label") != 0)
{
ObjectCreate("D_R3 label", OBJ_TEXT, 0, Time[20], D_R3);
ObjectSetText("D_R3 label", "                              D_R3 " +DoubleToStr(D_R3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_R3 label", 0, Time[0], D_R3);
}

if(ObjectFind("D_P label") != 0)
{
ObjectCreate("D_P label", OBJ_TEXT, 0, Time[0], D_P);
ObjectSetText("D_P label", "                               D_Pivot " +DoubleToStr(D_P,4), 8, "Arial",EMPTY);
}
else
{
ObjectMove("D_P label", 0, Time[0], D_P);
}

if(ObjectFind("D_S1 label") != 0)
{
ObjectCreate("D_S1 label", OBJ_TEXT, 0, Time[0], D_S1);
ObjectSetText("D_S1 label", "                              D_S1 " +DoubleToStr(D_S1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_S1 label", 0, Time[0], D_S1);
}

if(ObjectFind("D_S2 label") != 0)
{
ObjectCreate("D_S2 label", OBJ_TEXT, 0, Time[20], D_S2);
ObjectSetText("D_S2 label", "                              D_S2 " +DoubleToStr(D_S2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_S2 label", 0, Time[0], D_S2);
}

if(ObjectFind("D_S3 label") != 0)
{
ObjectCreate("D_S3 label", OBJ_TEXT, 0, Time[20], D_S3);
ObjectSetText("D_S3 label", "                              D_S3 " +DoubleToStr(D_S3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_S3 label", 0, Time[0], D_S3);
}

//--- Draw Pivot lines on chart
if(ObjectFind("D_S1 line") != 0)
{
ObjectCreate("D_S1 line", OBJ_HLINE, 0, Time[0], D_S1, Time[0], D_S1);
ObjectSet("D_S1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_S1 line", OBJPROP_WIDTH, 1);
ObjectSet("D_S1 line", OBJPROP_COLOR, s1color);
}
else
{
ObjectMove("D_S1 line", 0, Time[40], D_S1);
}

if(ObjectFind("D_S2 line") != 0)
{
ObjectCreate("D_S2 line", OBJ_HLINE, 0, Time[40], D_S2);
ObjectSet("D_S2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_S2 line", OBJPROP_WIDTH, 1);
ObjectSet("D_S2 line", OBJPROP_COLOR, s2color);
}
else
{
ObjectMove("D_S2 line", 0, Time[40], D_S2);
}

if(ObjectFind("D_S3 line") != 0)
{
ObjectCreate("D_S3 line", OBJ_HLINE, 0, Time[40], D_S3);
ObjectSet("D_S3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("D_S3 line", OBJPROP_WIDTH, s3width);
ObjectSet("D_S3 line", OBJPROP_COLOR, s3color);
}
else
{
ObjectMove("D_S3 line", 0, Time[40], D_S3);
}

if(ObjectFind("D_P line") != 0)
{
ObjectCreate("D_P line", OBJ_HLINE, 0, Time[40], D_P);
ObjectSet("D_P line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("D_P line", OBJPROP_WIDTH, pwidth);
ObjectSet("D_P line", OBJPROP_COLOR, pcolor);
}
else
{
ObjectMove("D_P line", 0, Time[40], D_P);
}

if(ObjectFind("D_R1 line") != 0)
{
ObjectCreate("D_R1 line", OBJ_HLINE, 0, Time[40], D_R1);
ObjectSet("D_R1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_R1 line", OBJPROP_WIDTH, 1);
ObjectSet("D_R1 line", OBJPROP_COLOR, r1color);
}
else
{
ObjectMove("D_R1 line", 0, Time[40], D_R1);
}

if(ObjectFind("D_R2 line") != 0)
{
ObjectCreate("D_R2 line", OBJ_HLINE, 0, Time[40], D_R2);
ObjectSet("D_R2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_R2 line", OBJPROP_WIDTH, 1);
ObjectSet("D_R2 line", OBJPROP_COLOR, r2color);
}
else
{
ObjectMove("D_R2 line", 0, Time[40], D_R2);
}

if(ObjectFind("D_R3 line") != 0)
{
ObjectCreate("D_R3 line", OBJ_HLINE, 0, Time[40], D_R3);
ObjectSet("D_R3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("D_R3 line", OBJPROP_WIDTH, r3width);
ObjectSet("D_R3 line", OBJPROP_COLOR, r3color);
}
else
{
ObjectMove("D_R3 line", 0, Time[40], D_R3);
}
}
//---- End of Pivot Line Draw



//------ Midpoints Pivots

if (daily == true && midpivots==true)
{

if(ObjectFind("D_M5 label") != 0)
{
ObjectCreate("D_M5 label", OBJ_TEXT, 0, Time[20], D_M5);
ObjectSetText("D_M5 label", "                              D_M5 " +DoubleToStr(D_M5,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M5 label", 0, Time[0], D_M5);
}

if(ObjectFind("D_M4 label") != 0)
{
ObjectCreate("D_M4 label", OBJ_TEXT, 0, Time[20], D_M4);
ObjectSetText("D_M4 label", "                              D_M4 " +DoubleToStr(D_M4,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M4 label", 0, Time[0], D_M4);
}

if(ObjectFind("D_M3 label") != 0)
{
ObjectCreate("D_M3 label", OBJ_TEXT, 0, Time[20], D_M3);
ObjectSetText("D_M3 label", "                              D_M3 " +DoubleToStr(D_M3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M3 label", 0, Time[0], D_M3);
}

if(ObjectFind("D_M2 label") != 0)
{
ObjectCreate("D_M2 label", OBJ_TEXT, 0, Time[20], D_M2);
ObjectSetText("D_M2 label", "                              D_M2 " +DoubleToStr(D_M2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M2 label", 0, Time[0], D_M2);
}

if(ObjectFind("D_M1 label") != 0)
{
ObjectCreate("D_M1 label", OBJ_TEXT, 0, Time[20], D_M1);
ObjectSetText("D_M1 label", "                              D_M1 " +DoubleToStr(D_M1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M1 label", 0, Time[0], D_M1);
}

if(ObjectFind("D_M0 label") != 0)
{
ObjectCreate("D_M0 label", OBJ_TEXT, 0, Time[20], D_M0);
ObjectSetText("D_M0 label", "                              D_M0 " +DoubleToStr(D_M0,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("D_M0 label", 0, Time[0], D_M0);
}

//---- Draw Midpoint Pivots on Chart
if(ObjectFind("D_M5 line") != 0)
{
ObjectCreate("D_M5 line", OBJ_HLINE, 0, Time[40], D_M5);
ObjectSet("D_M5 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M5 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M5 line", OBJPROP_COLOR, m5color);
}
else
{
ObjectMove("D_M5 line", 0, Time[40], D_M5);
}

if(ObjectFind("D_M4 line") != 0)
{
ObjectCreate("D_M4 line", OBJ_HLINE, 0, Time[40], D_M4);
ObjectSet("D_M4 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M4 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M4 line", OBJPROP_COLOR, m4color);
}
else
{
ObjectMove("D_M4 line", 0, Time[40], D_M4);
}

if(ObjectFind("D_M3 line") != 0)
{
ObjectCreate("D_M3 line", OBJ_HLINE, 0, Time[40], D_M3);
ObjectSet("D_M3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M3 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M3 line", OBJPROP_COLOR, m3color);
}
else
{
ObjectMove("D_M3 line", 0, Time[40], D_M3);
}

if(ObjectFind("D_M2 line") != 0)
{
ObjectCreate("D_M2 line", OBJ_HLINE, 0, Time[40], D_M2);
ObjectSet("D_M2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M2 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M2 line", OBJPROP_COLOR, m2color);
}
else
{
ObjectMove("D_M2 line", 0, Time[40], D_M2);
}

if(ObjectFind("D_M1 line") != 0)
{
ObjectCreate("D_M1 line", OBJ_HLINE, 0, Time[40], D_M1);
ObjectSet("D_M1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M1 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M1 line", OBJPROP_COLOR, m1color);
}
else
{
ObjectMove("D_M1 line", 0, Time[40], D_M1);
}

if(ObjectFind("D_M0 line") != 0)
{
ObjectCreate("D_M0 line", OBJ_HLINE, 0, Time[40], D_M0);
ObjectSet("D_M0 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("D_M0 line", OBJPROP_WIDTH, 1);
ObjectSet("D_M0 line", OBJPROP_COLOR, m0color);
}
else
{
ObjectMove("D_M0 line", 0, Time[40], D_M0);
}

}
//-------------=---------------------------------------------------------------------End of DAILY
//---------------------------------------------------------------------WEEKLY Pivot Lines --------------------
if (weekly==true)
   {
   if(ObjectFind("W_R1 label") != 0)
   {
      ObjectCreate("W_R1 label", OBJ_TEXT, 0, Time[0], W_R1);
      ObjectSetText("W_R1 label", "W_R1 " +DoubleToStr(W_R1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_R1 label", 0, Time[0], W_R1);
}

if(ObjectFind("W_R2 label") != 0)
{
ObjectCreate("W_R2 label", OBJ_TEXT, 0, Time[20], W_R2);
ObjectSetText("W_R2 label", "W_R2 " +DoubleToStr(W_R2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_R2 label", 0, Time[0], W_R2);
}

if(ObjectFind("W_R3 label") != 0)
{
ObjectCreate("W_R3 label", OBJ_TEXT, 0, Time[20], W_R3);
ObjectSetText("W_R3 label", "W_R3 " +DoubleToStr(W_R3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_R3 label", 0, Time[0], W_R3);
}

if(ObjectFind("W_P label") != 0)
{
ObjectCreate("W_P label", OBJ_TEXT, 0, Time[0], W_P);
ObjectSetText("W_P label", "W_Pivot " +DoubleToStr(W_P,4), 8, "Arial",EMPTY);
}
else
{
ObjectMove("W_P label", 0, Time[0], W_P);
}

if(ObjectFind("W_S1 label") != 0)
{
ObjectCreate("W_S1 label", OBJ_TEXT, 0, Time[0], W_S1);
ObjectSetText("W_S1 label", "W_S1 " +DoubleToStr(W_S1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_S1 label", 0, Time[0], W_S1);
}

if(ObjectFind("W_S2 label") != 0)
{
ObjectCreate("W_S2 label", OBJ_TEXT, 0, Time[20], W_S2);
ObjectSetText("W_S2 label", "W_S2 " +DoubleToStr(W_S2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_S2 label", 0, Time[0], W_S2);
}

if(ObjectFind("W_S3 label") != 0)
{
ObjectCreate("W_S3 label", OBJ_TEXT, 0, Time[20], W_S3);
ObjectSetText("W_S3 label", "W_S3 " +DoubleToStr(W_S3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_S3 label", 0, Time[0], W_S3);
}

//--- Draw Pivot lines on chart
if(ObjectFind("W_S1 line") != 0)
{
ObjectCreate("W_S1 line", OBJ_HLINE, 0, Time[40], W_S1);
ObjectSet("W_S1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_S1 line", OBJPROP_WIDTH, 1);
ObjectSet("W_S1 line", OBJPROP_COLOR, s1color);
}
else
{
ObjectMove("W_S1 line", 0, Time[40], W_S1);
}

if(ObjectFind("W_S2 line") != 0)
{
ObjectCreate("W_S2 line", OBJ_HLINE, 0, Time[40], W_S2);
ObjectSet("W_S2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_S2 line", OBJPROP_WIDTH, 1);
ObjectSet("W_S2 line", OBJPROP_COLOR, s2color);
}
else
{
ObjectMove("W_S2 line", 0, Time[40], W_S2);
}

if(ObjectFind("W_S3 line") != 0)
{
ObjectCreate("W_S3 line", OBJ_HLINE, 0, Time[40], W_S3);
ObjectSet("W_S3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("W_S3 line", OBJPROP_WIDTH, s3width);
ObjectSet("W_S3 line", OBJPROP_COLOR, s3color);
}
else
{
ObjectMove("W_S3 line", 0, Time[40], W_S3);
}

if(ObjectFind("W_P line") != 0)
{
ObjectCreate("W_P line", OBJ_HLINE, 0, Time[40], W_P);
ObjectSet("W_P line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("W_P line", OBJPROP_WIDTH, pwidth);
ObjectSet("W_P line", OBJPROP_COLOR, pcolor);
}
else
{
ObjectMove("W_P line", 0, Time[40], W_P);
}

if(ObjectFind("W_R1 line") != 0)
{
ObjectCreate("W_R1 line", OBJ_HLINE, 0, Time[40], W_R1);
ObjectSet("W_R1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_R1 line", OBJPROP_WIDTH, 1);
ObjectSet("W_R1 line", OBJPROP_COLOR, r1color);
}
else
{
ObjectMove("W_R1 line", 0, Time[40], W_R1);
}

if(ObjectFind("W_R2 line") != 0)
{
ObjectCreate("W_R2 line", OBJ_HLINE, 0, Time[40], W_R2);
ObjectSet("W_R2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_R2 line", OBJPROP_WIDTH, 1);
ObjectSet("W_R2 line", OBJPROP_COLOR, r2color);
}
else
{
ObjectMove("W_R2 line", 0, Time[40], W_R2);
}

if(ObjectFind("W_R3 line") != 0)
{
ObjectCreate("W_R3 line", OBJ_HLINE, 0, Time[40], W_R3);
ObjectSet("W_R3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("W_R3 line", OBJPROP_WIDTH, r3width);
ObjectSet("W_R3 line", OBJPROP_COLOR, r3color);
}
else
{
ObjectMove("W_R3 line", 0, Time[40], W_R3);
}
}
//---- End of Pivot Line Draw



//------ Midpoints Pivots

if (weekly == true && midpivots==true)
{

if(ObjectFind("W_M5 label") != 0)
{
ObjectCreate("W_M5 label", OBJ_TEXT, 0, Time[20], W_M5);
ObjectSetText("W_M5 label", "W_M5 " +DoubleToStr(W_M5,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M5 label", 0, Time[0], W_M5);
}

if(ObjectFind("W_M4 label") != 0)
{
ObjectCreate("W_M4 label", OBJ_TEXT, 0, Time[20], W_M4);
ObjectSetText("W_M4 label", "W_M4 " +DoubleToStr(W_M4,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M4 label", 0, Time[0], W_M4);
}

if(ObjectFind("W_M3 label") != 0)
{
ObjectCreate("W_M3 label", OBJ_TEXT, 0, Time[20], W_M3);
ObjectSetText("W_M3 label", "W_M3 " +DoubleToStr(W_M3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M3 label", 0, Time[0], W_M3);
}

if(ObjectFind("W_M2 label") != 0)
{
ObjectCreate("W_M2 label", OBJ_TEXT, 0, Time[20], W_M2);
ObjectSetText("W_M2 label", "W_M2 " +DoubleToStr(W_M2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M2 label", 0, Time[0], W_M2);
}

if(ObjectFind("W_M1 label") != 0)
{
ObjectCreate("W_M1 label", OBJ_TEXT, 0, Time[20], W_M1);
ObjectSetText("W_M1 label", "W_M1 " +DoubleToStr(W_M1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M1 label", 0, Time[0], W_M1);
}

if(ObjectFind("W_M0 label") != 0)
{
ObjectCreate("W_M0 label", OBJ_TEXT, 0, Time[20], W_M0);
ObjectSetText("W_M0 label", "W_M0 " +DoubleToStr(W_M0,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("W_M0 label", 0, Time[0], W_M0);
}

//---- Draw Midpoint Pivots on Chart
if(ObjectFind("W_M5 line") != 0)
{
ObjectCreate("W_M5 line", OBJ_HLINE, 0, Time[40], W_M5);
ObjectSet("W_M5 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M5 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M5 line", OBJPROP_COLOR, m5color);
}
else
{
ObjectMove("W_M5 line", 0, Time[40], W_M5);
}

if(ObjectFind("W_M4 line") != 0)
{
ObjectCreate("W_M4 line", OBJ_HLINE, 0, Time[40], W_M4);
ObjectSet("W_M4 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M4 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M4 line", OBJPROP_COLOR, m4color);
}
else
{
ObjectMove("W_M4 line", 0, Time[40], W_M4);
}

if(ObjectFind("W_M3 line") != 0)
{
ObjectCreate("W_M3 line", OBJ_HLINE, 0, Time[40], W_M3);
ObjectSet("W_M3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M3 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M3 line", OBJPROP_COLOR, m3color);
}
else
{
ObjectMove("W_M3 line", 0, Time[40], W_M3);
}

if(ObjectFind("W_M2 line") != 0)
{
ObjectCreate("W_M2 line", OBJ_HLINE, 0, Time[40], W_M2);
ObjectSet("W_M2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M2 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M2 line", OBJPROP_COLOR, m2color);
}
else
{
ObjectMove("W_M2 line", 0, Time[40], W_M2);
}

if(ObjectFind("W_M1 line") != 0)
{
ObjectCreate("W_M1 line", OBJ_HLINE, 0, Time[40], W_M1);
ObjectSet("W_M1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M1 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M1 line", OBJPROP_COLOR, m1color);
}
else
{
ObjectMove("W_M1 line", 0, Time[40], W_M1);
}

if(ObjectFind("W_M0 line") != 0)
{
ObjectCreate("W_M0 line", OBJ_HLINE, 0, Time[40], W_M0);
ObjectSet("W_M0 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("W_M0 line", OBJPROP_WIDTH, 1);
ObjectSet("W_M0 line", OBJPROP_COLOR, m0color);
}
else
{
ObjectMove("W_M0 line", 0, Time[40], W_M0);
}

}
//-------------=-------------------------------------------End WEEKLY 




//--------------------------------------------------------------------Monthly Pivot Lines --------------------
if (monthly == true)
{
if(ObjectFind("M_R1 label") != 0)
{
ObjectCreate("M_R1 label", OBJ_TEXT, 0, Time[0], M_R1);
ObjectSetText("M_R1 label", " M_R1 " +DoubleToStr(M_R1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_R1 label", 0, Time[0], M_R1);
}

if(ObjectFind("M_R2 label") != 0)
{
ObjectCreate("M_R2 label", OBJ_TEXT, 0, Time[20], M_R2);
ObjectSetText("M_R2 label", " M_R2 " +DoubleToStr(M_R2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_R2 label", 0, Time[0], M_R2);
}

if(ObjectFind("M_R3 label") != 0)
{
ObjectCreate("M_R3 label", OBJ_TEXT, 0, Time[20], M_R3);
ObjectSetText("M_R3 label", " M_R3 " +DoubleToStr(M_R3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_R3 label", 0, Time[0], M_R3);
}

if(ObjectFind("M_P label") != 0)
{
ObjectCreate("M_P label", OBJ_TEXT, 0, Time[0], M_P);
ObjectSetText("M_P label", "M_Pivot " +DoubleToStr(M_P,4), 8, "Arial",EMPTY);
}
else
{
ObjectMove("M_P label", 0, Time[0], M_P);
}

if(ObjectFind("M_S1 label") != 0)
{
ObjectCreate("M_S1 label", OBJ_TEXT, 0, Time[0], M_S1);
ObjectSetText("M_S1 label", "M_S1 " +DoubleToStr(M_S1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_S1 label", 0, Time[0], M_S1);
}

if(ObjectFind("M_S2 label") != 0)
{
ObjectCreate("M_S2 label", OBJ_TEXT, 0, Time[20], M_S2);
ObjectSetText("M_S2 label", "S2 " +DoubleToStr(M_S2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_S2 label", 0, Time[0], M_S2);
}

if(ObjectFind("M_S3 label") != 0)
{
ObjectCreate("M_S3 label", OBJ_TEXT, 0, Time[20], M_S3);
ObjectSetText("M_S3 label", "M_S3 " +DoubleToStr(M_S3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_S3 label", 0, Time[0], M_S3);
}

//--- Draw Pivot lines on chart
if(ObjectFind("M_S1 line") != 0)
{
ObjectCreate("M_S1 line", OBJ_HLINE, 0, Time[40], M_S1);
ObjectSet("M_S1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_S1 line", OBJPROP_WIDTH, 1);
ObjectSet("M_S1 line", OBJPROP_COLOR, s1color);
}
else
{
ObjectMove("M_S1 line", 0, Time[40], M_S1);
}

if(ObjectFind("M_S2 line") != 0)
{
ObjectCreate("M_S2 line", OBJ_HLINE, 0, Time[40], M_S2);
ObjectSet("M_S2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_S2 line", OBJPROP_WIDTH, 1);
ObjectSet("M_S2 line", OBJPROP_COLOR, s2color);
}
else
{
ObjectMove("M_S2 line", 0, Time[40], M_S2);
}

if(ObjectFind("M_S3 line") != 0)
{
ObjectCreate("M_S3 line", OBJ_HLINE, 0, Time[40], M_S3);
ObjectSet("M_S3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("M_S3 line", OBJPROP_WIDTH, s3width);
ObjectSet("M_S3 line", OBJPROP_COLOR, s3color);
}
else
{
ObjectMove("M_S3 line", 0, Time[40], M_S3);
}

if(ObjectFind("M_P line") != 0)
{
ObjectCreate("M_P line", OBJ_HLINE, 0, Time[40], M_P);
ObjectSet("M_P line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("M_P line", OBJPROP_WIDTH, pwidth);
ObjectSet("M_P line", OBJPROP_COLOR, pcolor);
}
else
{
ObjectMove("M_P line", 0, Time[40], M_P);
}

if(ObjectFind("M_R1 line") != 0)
{
ObjectCreate("M_R1 line", OBJ_HLINE, 0, Time[40], M_R1);
ObjectSet("M_R1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_R1 line", OBJPROP_WIDTH, 1);
ObjectSet("M_R1 line", OBJPROP_COLOR, r1color);
}
else
{
ObjectMove("M_R1 line", 0, Time[40], M_R1);
}

if(ObjectFind("M_R2 line") != 0)
{
ObjectCreate("M_R2 line", OBJ_HLINE, 0, Time[40], M_R2);
ObjectSet("M_R2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_R2 line", OBJPROP_WIDTH, 1);
ObjectSet("M_R2 line", OBJPROP_COLOR, r2color);
}
else
{
ObjectMove("M_R2 line", 0, Time[40], M_R2);
}

if(ObjectFind("M_R3 line") != 0)
{
ObjectCreate("M_R3 line", OBJ_HLINE, 0, Time[40], M_R3);
ObjectSet("M_R3 line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("M_R3 line", OBJPROP_WIDTH, r3width);
ObjectSet("M_R3 line", OBJPROP_COLOR, r3color);
}
else
{
ObjectMove("M_R3 line", 0, Time[40], M_R3);
}
}
//---- End of Pivot Line Draw



//------ Midpoints Pivots

if (monthly == true && midpivots==true)
{

if(ObjectFind("M_M5 label") != 0)
{
ObjectCreate("M_M5 label", OBJ_TEXT, 0, Time[20], M_M5);
ObjectSetText("M_M5 label", " M_M5 " +DoubleToStr(M_M5,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M5 label", 0, Time[0], M_M5);
}

if(ObjectFind("M_M4 label") != 0)
{
ObjectCreate("M_M4 label", OBJ_TEXT, 0, Time[20], M_M4);
ObjectSetText("M_M4 label", " M_M4 " +DoubleToStr(M_M4,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M4 label", 0, Time[0], M_M4);
}

if(ObjectFind("M_M3 label") != 0)
{
ObjectCreate("M_M3 label", OBJ_TEXT, 0, Time[20], M_M3);
ObjectSetText("M_M3 label", " M_M3 " +DoubleToStr(M_M3,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M3 label", 0, Time[0], M_M3);
}

if(ObjectFind("M_M2 label") != 0)
{
ObjectCreate("M_M2 label", OBJ_TEXT, 0, Time[20], M_M2);
ObjectSetText("M_M2 label", " M_M2 " +DoubleToStr(M_M2,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M2 label", 0, Time[0], M_M2);
}

if(ObjectFind("M_M1 label") != 0)
{
ObjectCreate("M_M1 label", OBJ_TEXT, 0, Time[20], M_M1);
ObjectSetText("M_M1 label", " M_M1 " +DoubleToStr(M_M1,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M1 label", 0, Time[0], M_M1);
}

if(ObjectFind("M_M0 label") != 0)
{
ObjectCreate("M_M0 label", OBJ_TEXT, 0, Time[20], M_M0);
ObjectSetText("M_M0 label", " M_M0 " +DoubleToStr(M_M0,4), 8, "Arial", EMPTY);
}
else
{
ObjectMove("M_M0 label", 0, Time[0], M_M0);
}

//---- Draw Midpoint Pivots on Chart
if(ObjectFind("M_M5 line") != 0)
{
ObjectCreate("M_M5 line", OBJ_HLINE, 0, Time[40], M_M5, Time[20], M_M5);
ObjectSet("M_M5 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M5 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M5 line", OBJPROP_COLOR, m5color);
}
else
{
ObjectMove("M_M5 line", 0, Time[40], M_M5);
}

if(ObjectFind("M_M4 line") != 0)
{
ObjectCreate("M_M4 line", OBJ_HLINE, 0, Time[40], M_M4);
ObjectSet("M_M4 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M4 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M4 line", OBJPROP_COLOR, m4color);
}
else
{
ObjectMove("M_M4 line", 0, Time[40], M_M4);
}

if(ObjectFind("M_M3 line") != 0)
{
ObjectCreate("M_M3 line", OBJ_HLINE, 0, Time[40], M_M3);
ObjectSet("M_M3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M3 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M3 line", OBJPROP_COLOR, m3color);
}
else
{
ObjectMove("M_M3 line", 0, Time[40], M_M3);
}

if(ObjectFind("M_M2 line") != 0)
{
ObjectCreate("M_M2 line", OBJ_HLINE, 0, Time[40], M_M2);
ObjectSet("M_M2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M2 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M2 line", OBJPROP_COLOR, m2color);
}
else
{
ObjectMove("M_M2 line", 0, Time[40], M_M2);
}

if(ObjectFind("M_M1 line") != 0)
{
ObjectCreate("M_M1 line", OBJ_HLINE, 0, Time[40], M_M1);
ObjectSet("M_M1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M1 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M1 line", OBJPROP_COLOR, m1color);
}
else
{
ObjectMove("M_M1 line", 0, Time[40], M_M1);
}

if(ObjectFind("M_M0 line") != 0)
{
ObjectCreate("M_M0 line", OBJ_HLINE, 0, Time[40], M_M0);
ObjectSet("M_M0 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M_M0 line", OBJPROP_WIDTH, 1);
ObjectSet("M_M0 line", OBJPROP_COLOR, m0color);
}
else
{
ObjectMove("M_M0 line", 0, Time[40], M_M0);
}
}
}
//---- End of Pivot Line Draw
void TSManager()
{
  if (TrailingStop>0)
  {
    cnt=OrdersTotal()-1;
    while(cnt>=0)
    {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if (IsMyOrder())
      {
        if (OrderType()==OP_SELL) 
        {		
          if ((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))>=(TrailingStop*Point+Pips*Point)) 
          {						
            if (OrderStopLoss()-TrailingStep*Point>(MarketInfo(OrderSymbol(),MODE_ASK)+TrailingStop*Point))
            {										    
              if(GetTradeContext()) RefreshRates();
              result=OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_ASK)+TrailingStop*Point,OrderTakeProfit(),0,Purple);
              if(result!=true) Print("Trailing Stop Error = ", GetLastError());
              else OrderPrint();					
            }
          }
        }
        if (OrderType()==OP_BUY)
        {
          if ((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())>=(TrailingStop*Point+Pips*Point)) 
          {
            if (OrderStopLoss()+TrailingStep*Point<(MarketInfo(OrderSymbol(),MODE_BID)-TrailingStop*Point)) 
            {					   
              if(GetTradeContext()) RefreshRates();
              result=OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_BID)-TrailingStop*Point,OrderTakeProfit(),0,ArrowsColor);		
              if(result!=true) Print("Trailing Stop Error = ", GetLastError());                  
              else OrderPrint();
              return(0);
            }
          }
        }
      }
      cnt--;
    }
  }
}


void OpenMarketOrders(int mySignal)
// mySignal = 1 for sell, 2 for buy, 3 for no signal.
{         
  int cnt=0, gle=0, ticket, attempts, myCount;
  bool ModifySucceeded;
  
  if ((mySignal==1 || mySignal==3) 
  && (dtSellAllowed < TimeCurrent())
  && ((CurrentOpenOrders[OP_SELL]>0 && CurrentOpenOrders[OP_SELL]<MaxTrades && (Bid-LastOrderOpenPrice[OP_SELL]>=Pips*Point) && (LastOrderOpenPrice[OP_SELL]>0))
  || (CurrentOpenOrders[OP_SELL]==0 && mySignal==1)))
  {	     		
    myCount=1;
    if (RecoveryMode && CurrentOpenOrders[OP_SELL]>0 && CurrentOpenOrders[OP_SELL]<MaxTrades && Bid-LastOrderOpenPrice[OP_SELL]>=Pips*Point*2)
      myCount = MathFloor((Bid-LastOrderOpenPrice[OP_SELL])/(Pips*Point));
    CalculateLotArray(OP_SELL,CurrentOpenOrders[OP_SELL]);
    
    for(cnt=0;cnt<myCount;cnt++)
    {
      ticket=-1;
      attempts=0;
      SellPrice=Bid;				
      if (TakeProfit==0) tp=0;
      else tp=SellPrice-TakeProfit*Point;	
      if (StopLoss==0) sl=0;
      //************************************************************************************************************************
      //*************TOM - modified from "else sl=SellPrice+StopLoss*Point;" to look up stop loss from 1st trade ***************
      else sl=CalcStopLoss(OP_SELL);
      //************************************************************************************************************************
      myBaseLot=LotSizeArray[CurrentOpenOrders[OP_SELL],OP_SELL];

      while( ticket < 0)
      {
        if(GetTradeContext()) RefreshRates();
        if(AccountFreeMarginCheck(Symbol(),OP_SELL,myBaseLot)<=0 || GetLastError()==134)
        {
          Print("NOT ENOUGH MONEY TO OPEN SELL ORDER! No further attempts to open new trades will occur.  Monitoring existing orders.");
          Alert("NOT ENOUGH MONEY TO OPEN SELL ORDER! No further attempts to open new trades will occur.  Monitoring existing orders.");
          TradingDisabled=true;
          return;
        }
  
        ticket=OrderSend(Symbol(),OP_SELL,myBaseLot,NormalizeDouble(SellPrice,myDigits),slippage,0,0,EAName+" EA "+MagicNumber,MagicNumber,0,ArrowsColor);
        if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
          {
            Print("SELL order opened : ",OrderOpenPrice());
            LastOrderOpenPrice[OP_SELL]=OrderOpenPrice();
            LastOrderOpenTime[OP_SELL]=OrderOpenTime();
            UpdateOrderStatus(true);
            break;
          }
        }         			
        else
        {
          gle=GetLastError();
          if (gle==2 || gle==144)
          {
            dtSellAllowed = TimeCurrent() + 3600;
            Print("Manual Trade Confirmation Dialog aborted. No Sell Positions will be attempted for the next 1 hour.");
            return;
          }
          Print("Error opening SELL order : ",gle);
          attempts++;
          Sleep(5000);
          RefreshRates();
        }
        if(attempts >= 20)
        {
          Print("20 attempts to open SELL position have failed");
          break;
        }
      }	
      ModifySucceeded=false;
      attempts=0;
      while(!ModifySucceeded && attempts<100)
      {
        if(GetTradeContext()) RefreshRates();
        ModifySucceeded=OrderModify(ticket,OrderOpenPrice(),sl,tp,0,GreenYellow);
        if(!ModifySucceeded)
        {
          gle=GetLastError();
          if (gle==2 || gle==144 || gle==4051)
          {
            Print("Manual Trade Confirmation Dialog aborted or invalid ticket. No Sell Positions will be attempted for the next 1 hour.");
            dtSellAllowed = TimeCurrent() + 3600;
            return;
          }
          Print("Error modifying SELL order : ",gle);
          attempts++;
          Sleep(2000);
          RefreshRates();
        }
      }
      if(attempts >= 50)
      {
        Print("A Critical Error Occurred! The expert could not modify SELL position!");
      }
      //************************************************************************************************************************
      //*************TOM - added call to new routine to revise all trades in set to new tp value *******************************
      if (tp > 0)
      {
        ModifyTakeProfits(tp, MagicNumber, OP_SELL);
      }
      //************************************************************************************************************************
    }
  }

  if ((mySignal==2 || mySignal==3) 
  && (dtBuyAllowed < TimeCurrent())
  && ((CurrentOpenOrders[OP_BUY]>0 && CurrentOpenOrders[OP_BUY]<MaxTrades && (LastOrderOpenPrice[OP_BUY]-Ask>=Pips*Point) && (LastOrderOpenPrice[OP_BUY]>0))
  || (CurrentOpenOrders[OP_BUY]==0 && mySignal==2)))
  {			      
    myCount=1;
    if (RecoveryMode && CurrentOpenOrders[OP_BUY]>0 && CurrentOpenOrders[OP_BUY]<MaxTrades && LastOrderOpenPrice[OP_BUY]-Ask>=Pips*Point*2)
      myCount = MathFloor((LastOrderOpenPrice[OP_BUY]-Ask)/(Pips*Point));
    CalculateLotArray(OP_BUY,CurrentOpenOrders[OP_BUY]);

    for(cnt=0;cnt<myCount;cnt++)
    {
      ticket=-1;
      attempts=0;
      BuyPrice=Ask;
      if (TakeProfit==0) tp=0;
      else tp=BuyPrice+TakeProfit*Point;
      if (StopLoss==0) sl=0;
      //************************************************************************************************************************
      //*************TOM - modified from "else sl=BuyPrice-StopLoss*Point;" to look up stop loss from 1st trade ***************
      else sl=CalcStopLoss(OP_BUY);
      //************************************************************************************************************************
      myBaseLot=LotSizeArray[CurrentOpenOrders[OP_BUY],OP_BUY];
      
      while( ticket < 0)
      {
        if(GetTradeContext()) RefreshRates();
        if(AccountFreeMarginCheck(Symbol(),OP_BUY,myBaseLot)<=0 || GetLastError()==134)
        {
          Print("NOT ENOUGH MONEY TO OPEN BUY ORDER! No further attempts to open new trades will occur.  Monitoring existing orders.");
          Alert("NOT ENOUGH MONEY TO OPEN BUY ORDER! No further attempts to open new trades will occur.  Monitoring existing orders.");
          TradingDisabled=true;
          return;
        }

        ticket=OrderSend(Symbol(),OP_BUY,myBaseLot,NormalizeDouble(BuyPrice,myDigits),slippage,0,0,EAName+" EA "+MagicNumber,MagicNumber,0,ArrowsColor);
        if(ticket>0)
        {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
          {
            Print("BUY order opened : ",OrderOpenPrice());
            LastOrderOpenPrice[OP_BUY]=OrderOpenPrice();
            LastOrderOpenTime[OP_BUY]=OrderOpenTime();
            UpdateOrderStatus(true);
            break;
          }
        }         			
        else
        {
          gle=GetLastError();
          if (gle==2 || gle==144)
          {
            Print("Manual Trade Confirmation Dialog aborted. No Buy Positions will be attempted for the next 1 hour.");
            dtBuyAllowed = TimeCurrent() + 3600;
            return;
          }
          Print("Error opening BUY order : ",gle);
          attempts++;
          Sleep(5000);
          RefreshRates();
        }
        if(attempts >= 20)
        {
          Print("20 attempts to open BUY position have failed");
          break;
        }
      }
      ModifySucceeded=false;
      attempts=0;
      while(!ModifySucceeded && attempts<100)
      {
        if(GetTradeContext()) RefreshRates();
        ModifySucceeded=OrderModify(ticket,OrderOpenPrice(),sl,tp,0,GreenYellow);
        if(!ModifySucceeded)
        {
          gle=GetLastError();
          if (gle==2 || gle==144 || gle==4051)
          {
            Print("Manual Trade Confirmation Dialog aborted or invalid ticket. No Buy Positions will be attempted for the next 1 hour.");
            dtBuyAllowed = TimeCurrent() + 3600;
            return;
          }
          Print("Error modifying BUY order : ",gle);
          Print("cnt=",cnt,", myBaseLot=",myBaseLot,", BuyPrice=",BuyPrice,", ticket=",ticket);
          attempts++;
          Sleep(2000);
          RefreshRates();
        }
      }
      if(attempts >= 50)
      {
        Print("A Critical Error Occurred! The expert could not modify BUY position!");
      }
      //************************************************************************************************************************
      //*************TOM - added call to new routine to revise all trades in set to new tp value *******************************
      if (tp > 0)
      {
        ModifyTakeProfits(tp, MagicNumber, OP_BUY);
      }
      //************************************************************************************************************************
    }
  }
}   


bool GetTradeContext()
{
  bool hadToWait=false;
  
  while(!IsTradeAllowed())
  {
    Sleep(5000);
    hadToWait=true;
  }
  
  while(IsTradeContextBusy())
  {
    Sleep(200);
    hadToWait=true;
  }
  
  return(hadToWait);
}


void DeleteAllObjects()
{
  ObjectDelete("MaxDD");
  ObjectDelete("B/E");
  int    obj_total=ObjectsTotal();
  string name;
  for(int i=0;i<=obj_total;i++)
  {
    name=ObjectName(i);
    if (name!="") ObjectDelete(name);
  }
}


bool IsTradingTime()
{
   if (BlackoutTime()) return(false);  // Added for blackout dates
   int currentDay = TimeDayOfWeek(TimeCurrent() - 3600 * ManualGMToffset);
   int currentHour = TimeHour(TimeCurrent() - 3600 * ManualGMToffset);
   if (!TradeOnFriday && currentDay >= 5) return(false); // GMT Adjusted Day of Week
   if (currentDay >= 5 && currentHour >= FridayGMTStopHour && FridayGMTStopHour >= 0) return(false);
   if (GMTStartHour == GMTStopHour) return(true);
   return(IsTradingTimeSub(GMTStartHour, GMTStopHour));
}


bool IsTradingTimeSub(int myStartHour, int myEndHour)
{
   int currentHour = TimeHour(TimeCurrent() - 3600 * ManualGMToffset);
   int adjustedEndHour = NormalizedHourParam(myEndHour - 1);

   if (myStartHour == adjustedEndHour) if (currentHour != myStartHour) return(false);
   if (myStartHour > adjustedEndHour)  if (currentHour < myStartHour && currentHour > adjustedEndHour) return(false);
   if (myStartHour < adjustedEndHour)  if (currentHour < myStartHour || currentHour > adjustedEndHour) return(false);

   return(true);
}


string GMTSourceURL = "http://wwp.greenwichmeantime.com/time/scripts/clock-8/x.php";
string GMTUserAgent = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0; Trident/4.0)";
int AutoGMTOffset()
{
  string gvName1 = StringConcatenate(AccountNumber(),"_GMTOffset_Value");
  string gvName2 = StringConcatenate(AccountNumber(),"_GMTOffset_Timestamp");
  double gvValue1 = GlobalVariableGet(gvName1);
  double gvValue2 = GlobalVariableGet(gvName2);

  if ((GlobalVariableCheck(gvName1) && GlobalVariableCheck(gvName2))
  && !((DayOfWeek() < TimeDayOfWeek(gvValue2)) ||
       (DayOfWeek()== TimeDayOfWeek(gvValue2) && TimeCurrent()-gvValue2 > 86400) ||
       (DayOfWeek() > TimeDayOfWeek(gvValue2) && TimeCurrent()-gvValue2 > 604800)))
      
  // Values are valid and we have not passed over a Sunday since the last valid time GMT was checked
  // We add the above restrictions and use the global variable to minimize hits to the new public time source
  {
    //Print ("Successfully read GMT Offset from globals");
    return (gvValue1);
  }
  else
  {
    Comment("Connecting to public GMT time source...");
    string status;
    int result, offsetTmp;
    InternetHandle = InternetOpenA(GMTUserAgent, 0, "0", "0", 0);
    string myBuffer = "ABCDEFGHIJ";
    if (!RetrieveURLData(GMTSourceURL, myBuffer))
    {
      if (InternetHandle == 0) status = "Error connecting to AutoGMT time source.";
      result = -999999999;
      Comment(status);
      Print(status);
      Sleep(3000);
    }
    else
    {
      offsetTmp = TimeCurrent() - StrToInteger(myBuffer);
      result = MathFloor((offsetTmp + 1800) / 3600);
      if (result <= 24 && result >= -24)
      {
        GlobalVariableSet(gvName1,result);
        GlobalVariableSet(gvName2,TimeCurrent());
        //Print ("Successfully stored GMT Offset in globals");
      }
    }
    InternetCloseHandle(InternetHandle);
    return(result);
  }
}


bool RetrieveURLData(string URL, string &datum)
{
  int thisHandle = InternetOpenUrlA(InternetHandle, URL, "0", 0, -2080374528, 0);
  if (thisHandle == 0) return (false); //failure
  int a[] = {1};
  string anotherBuffer = "abcdefghij";
  int myStatus = InternetReadFile(thisHandle, anotherBuffer, 10, a);
  if (thisHandle != 0) InternetCloseHandle(thisHandle);
  datum = anotherBuffer;
  return(true); //since datum is a pointer, its contents updated between functions
}


// Normalize hours to fall into 0-23 range, regardless of input
int NormalizedHourParam(int myParam)
{
  while (true)
  {
    if (myParam >= 24)
    {
       myParam -= 24;
       continue;
    }
    if (myParam >= 0) break;
    myParam += 24;
  }
  return(myParam);
}


// Track Draw Down statistics for this traded symbol
void TrackDrawDown()
{
  double OpenProfit = SPProfit[0]+SPProfit[1];
  if (OpenProfit < MaxDD) MaxDD = OpenProfit;
  if ((OpenProfit/AccountBalance())*100 < MaxPercentDD) MaxPercentDD = (OpenProfit/AccountBalance())*100;

  if (ShowDDinfoOnChart)
  {
    ObjectCreate( "B/E", OBJ_LABEL,0,0,0,0,0,0);
    ObjectSet(    "B/E", OBJPROP_CORNER,3);
    ObjectSet(    "B/E", OBJPROP_XDISTANCE, 3);
    ObjectSet(    "B/E", OBJPROP_YDISTANCE, 30);
    ObjectSetText("B/E", "B/E: $"+DoubleToStr(NormalizeDouble(AccountBalance(),2),2)+"/"+DoubleToStr(NormalizeDouble(AccountEquity(),2),2),12,"Impact",White);

    ObjectCreate( "MaxDD", OBJ_LABEL,0,0,0,0,0,0);
    ObjectSet(    "MaxDD", OBJPROP_CORNER,3);
    ObjectSet(    "MaxDD", OBJPROP_XDISTANCE, 3);
    ObjectSet(    "MaxDD", OBJPROP_YDISTANCE, 2);
    ObjectSetText("MaxDD", "RDD Max: $"+DoubleToStr(NormalizeDouble(MaxDD,2),2)+"/"+DoubleToStr(NormalizeDouble(MaxPercentDD,2),1)+"%",12,"Impact",White);
  }
  return;
}


// Check for any conditions where we should close out trades and possibly halt further trading on this symbol
// return 0: no close signal, 1: close for buy, sell or both, 2: close for buy, sell or both, and Disable EA
// return 3: Signal Disabling of EA due to Draw Down Control
int CloseOutTradesCheck()
{
  int result = 0;
  
  // Check to see if I reached my equity + closed profit target for this symbol + magic numbers
  if (MyMoneyProfitTarget)
  {
    MMProfit[0]=0;
    MMProfit[1]=0;
    // First, we iterate through all open positions for this symbol
    for(cnt=0;cnt<OrdersTotal();cnt++)
    {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
        if (IsMyOrder()) MMProfit[OrderType()] += OrderProfit() + OrderSwap() + OrderCommission();
      }
    }
    
    // Next, we iterate through all available history for this symbol + magic numbers 
    for(cnt=0;cnt<OrdersHistoryTotal();cnt++)
    {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY))
      {
        if (IsMyOrder()) MMProfit[OrderType()] += OrderProfit() + OrderSwap() + OrderCommission();
      }
    }

    // Finally, see if the criteria is met or not
    if ((MMProfit[OP_BUY]+MMProfit[OP_SELL]) >= My_Money_Profit_Target)
    {
      text = text + "\nClosing all orders and stop trading because My_Money_Profit_Target reached for this symbol.";
      Print("Closing all orders and stop trading because My_Money_Profit_Target reached for this symbol.");
      Print("Profit: ",NormalizeDouble(MMProfit[OP_BUY]+MMProfit[OP_SELL],2)," Equity: ",NormalizeDouble(AccountEquity(),2));
      result = 2;
      exitBuy = true;
      exitSell = true;
    }
  }

  // SecureProfit Protection: Close out long running trades with a small profit
  SPProfit[0]=0;
  SPProfit[1]=0;
  for(cnt=0;cnt<OrdersTotal();cnt++)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
    {
      if (IsMyOrder()) SPProfit[OrderType()] += OrderProfit() + OrderSwap() + OrderCommission();
    }
  }

  if (SecureProfitProtection && SPProfit[OP_BUY]>=SecureProfit && MarketOpenOrders[OP_BUY]>=OrderstoProtect) 
  {
    text = text + "\nClosing BUY orders because account protection with SecureProfit was triggered.";
    Print("Closing BUY orders because account protection with SecureProfit was triggered.");
    Print("Balance: ",NormalizeDouble(AccountBalance(),2)," Equity: ", NormalizeDouble(AccountEquity(),2)," Profit: ",NormalizeDouble(SPProfit[OP_BUY],2));
    result = 1;
    exitBuy = true;
  }

  if (SecureProfitProtection && SPProfit[OP_SELL]>=SecureProfit && MarketOpenOrders[OP_SELL]>=OrderstoProtect) 
  {
    text = text + "\nClosing SELL orders because account protection with SecureProfit was triggered.";
    Print("Closing SELL orders because account protection with SecureProfit was triggered.");
    Print("Balance: ",NormalizeDouble(AccountBalance(),2)," Equity: ", NormalizeDouble(AccountEquity(),2)," Profit: ",NormalizeDouble(SPProfit[OP_SELL],2));
    result = 1;
    exitSell = true;
  }


  // Check to see if any trades recently closed due to hitting StopLoss or TakeProfit, if so, close out that sequence
  //UpdateOrderStatus(false); // Refresh current open order count, but leave previous count alone
  UpdateOrderStatus(true); // Refresh current open order count, disable auto-closing routine
  if (PreviousOpenOrders[OP_BUY] > CurrentOpenOrders[OP_BUY])
  {
    exitBuy = true;
    result = 1;
  }

  if (PreviousOpenOrders[OP_SELL] > CurrentOpenOrders[OP_SELL])
  {
    exitSell = true;
    result = 1;
  }


  // Close out any open trades if TTMGoFlat=true and we are outside of trading hours or trading days
  if (!IsTradingTime() && TTMGoFlat && CurrentOpenOrders[0]+CurrentOpenOrders[1]>0)
  {
    text = text + "\nClosing orders because outside of trading window.";
    Print("Closing orders because outside of trading window.");
    Print("Balance: ",NormalizeDouble(AccountBalance(),2)," Equity: ", NormalizeDouble(AccountEquity(),2)," Profit: ",NormalizeDouble(SPProfit[OP_BUY]+SPProfit[OP_SELL],2));
    exitBuy = true;
    exitSell = true;
    result = 1;
  }


  // If DDC thresholds are breached, go flat and disabled further trading
  if ((MaxDDControl && MathAbs(MaxDD)>=MathAbs(MaxAllowedDD)) || (MaxPercentDDControl && MathAbs(MaxPercentDD)>=MathAbs(MaxAllowedPercentDD)))
  {
    exitBuy = true;
    exitSell = true;
    result = 3;
  }

  return(result);   
}


// All the fancy risk management code is here.  If mm=0, just use the user-specified lot size.
// If mm=1, use the basic risk multiplier approach.  If mm=2, set max % of account balance to risk per trade sequence
void CalculateLotArray(int myDirection,int openTradeCount)
{
  double MaxLossAmount;
  if (mm <= 0 || mm > 2 )
  {
    LotSizeArray[0,myDirection]=NormalizedLots(Lots,true);
    for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=LotSizeArray[cnt-1,myDirection]*multiply;
    for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=NormalizedLots(LotSizeArray[cnt,myDirection],true);
    if (openTradeCount==0) LotSizeArray[99,myDirection]=AccountBalance();
  }

  if (mm == 1)
  {
    if (openTradeCount==0 || (openTradeCount>0 && AccountBalance() > LotSizeArray[99,myDirection]))
    // Only recalc if no trades open or if account balance has increased since the trade sequence has begun
    {
      double myLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      if (TradeMicroLots) myLotStep = 0.01;
      BaseLot=MathCeil(AccountBalance()*risk/10000)/100; // BaseLot amount to 0.01 precision
      BaseLot=BaseLot * 100000 / MarketInfo(Symbol(), MODE_LOTSIZE); // Adjust for broker lot size information (mini vs. std)
      LotSizeArray[0,myDirection]=NormalizedLots(BaseLot,true);
      for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=LotSizeArray[cnt-1,myDirection]*multiply;
      for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=NormalizedLots(LotSizeArray[cnt,myDirection],true);
      if (openTradeCount==0) LotSizeArray[99,myDirection]=AccountBalance();
    }
  }

  if (mm == 2)
  {
    /* Example with 600 PIP SL, 90 PIP spacing, 1.7x Lot Size multiplier:
    600 + 510*1.7^1 + 420*1.7^2 + 330*1.7^3 + 240*1.7^4 + 150*1.7^5 = XAdjPips
    Total = MarketInfo(Symbol(), MODE_TICKVALUE) * XAdjPips;
    Risk = Total / AccountBalance();

    Therefore, if: 
    1 lot = 0.33 from the tick_value, which is based on 1 standard lot suppose it results in 33% risk
    X lot = 0.10 but we want the lot size equivalent of just 10% of account risk
    X = 0.1/0.33 converts to: risk% * accountbalance() / total

    Finally:
    BaseLot = risk% * accountbalance() / total;
    
    This risk model is not like mm=1, which steps up risk in abrupt steps, especially on smaller account sizes.

    This special MM system uses the Outside In Risk Approach... or balanced risk approach:
    Note that using this method, the risk is first stepped up from the trades that come later in the sequence
    since it is less risky to add 0.01 lot to the 6th trade than it is to add 0.01 lot to the first trade.
    This results in a higher Profit Factor with a slightly lower draw down.
    
    Thank you, Tom Bradbury, for the idea to add in risk from the "outside in!"
    */
    
    if (MaxTrades>0 && (openTradeCount==0 || (openTradeCount>0 && AccountBalance() > LotSizeArray[99,myDirection])))
    // Only recalc if no trades open or if account balance has increased since the trade sequence has begun
    {
      MaxLossAmount = 0;
      for (cnt=0;cnt<MaxTrades;cnt++) MaxLossAmount += MathMax((StopLoss - cnt*Pips),0) * MathPow(multiply,cnt); //TB: MathMax added
      BaseLot = (risk/100) * AccountBalance() / (MarketInfo(Symbol(), MODE_TICKVALUE) * MaxLossAmount);
      double MaxTradeLotSize1 = NormalizedLots(NormalizedLots(BaseLot,false) * MathPow(multiply,MaxTrades-1),true);
      double MaxTradeLotSize2 = NormalizedLots(BaseLot * MathPow(multiply,MaxTrades-1),true);
      if (MaxTradeLotSize2>=MaxTradeLotSize1)
      { // Assign incrementally increasing lot size values from the outside in to ramp up risk more evenly
        // Also called to handle when MaxTradeLotSize exceeds maximum allowed by broker
        LotSizeArray[MaxTrades-1,myDirection]=MaxTradeLotSize2;
        for (cnt=MaxTrades-2;cnt>=0;cnt--) LotSizeArray[cnt,myDirection]=LotSizeArray[cnt+1,myDirection]/multiply;
        for (cnt=MaxTrades-2;cnt>=0;cnt--) LotSizeArray[cnt,myDirection]=NormalizedLots(LotSizeArray[cnt,myDirection],false);
      }
      else
      { // BaseLot is below Minimum Allowed Lotsize, so MaxTradeLotSize2 not large enough to properly spread out the risk
        LotSizeArray[0,myDirection]=NormalizedLots(BaseLot,false);
        for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=LotSizeArray[cnt-1,myDirection]*multiply;
        for (cnt=1;cnt<MaxTrades;cnt++) LotSizeArray[cnt,myDirection]=NormalizedLots(LotSizeArray[cnt,myDirection],true);
      }
      if (openTradeCount==0) LotSizeArray[99,myDirection]=AccountBalance();
    }
  }

  MaxLossAmount = 0;
  for (cnt=0;cnt<MaxTrades;cnt++) MaxLossAmount += (StopLoss - cnt*Pips) * LotSizeArray[cnt,myDirection];
  if (myDirection == OP_SELL)
    ActualRiskPercentS = (MarketInfo(Symbol(), MODE_TICKVALUE) * MaxLossAmount * 100) / AccountBalance();
  if (myDirection == OP_BUY)
    ActualRiskPercentB = (MarketInfo(Symbol(), MODE_TICKVALUE) * MaxLossAmount * 100) / AccountBalance();
  
  if (!IsTesting()) WriteLotArray(); // Write Lot Array to Globals.  This allows the specific lot size sequences to be preserved
                                     // if Meta Trader is restarted.
}


// Always return a lot size that the broker will accept to avoid error opening orders
// Lot size will be no smaller than the minimum, no larger than the maximum, and will have the proper precision
double NormalizedLots(double myLotSize, bool myMethod)
{
  double myLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
  if (TradeMicroLots) myLotStep = 0.01;
  if (myMethod) myLotSize = MathCeil(myLotSize / myLotStep) * myLotStep; // Conform to broker-required lot step requirment
  else myLotSize = MathFloor(myLotSize / myLotStep) * myLotStep; // For calculating "outside in" lot requirements
  if (myLotSize<MarketInfo(Symbol(), MODE_MINLOT)) myLotSize=MarketInfo(Symbol(), MODE_MINLOT);
  if (myLotSize>MarketInfo(Symbol(), MODE_MAXLOT)) myLotSize=MarketInfo(Symbol(), MODE_MAXLOT); 
  return(myLotSize);
}


// Get all the time variables set to a proper 0-23 range after adjusting for GMT offset using public time server
// or manual GMT offset depending on the configuration parameter externs
// Following function updated on 20100211 to handle errors better
int InitializeTimeVariables()
{
  int tmpGMToffset;
  string GMTMode;
  if (UseAutoGMToffset)
  {
    if (!IsTesting())
    {
      tmpGMToffset = AutoGMTOffset();
      if (tmpGMToffset > 24 || tmpGMToffset < -24)
      {
        if (AutoFallbackOnFail)
        {
          GMTMode = " (auto-fallback)";
        }  
        else
        {
          text="Failure getting AutoGMToffset, cannot open time-based trades until condition clears.";
          Comment(text);
          Print(text);
          Sleep(120000); // After 2 minutes, we will try again.
          return(-1);
        }
      }
      else
      {
        ManualGMToffset = tmpGMToffset;
        GMTMode = " (auto)";
      }
    }
    else
    {
      text="WARNING: When backtesting, only ManualGMTOffset value can be used, ensure it is set correctly!";
      Print(text);
      GMTMode = " (manual)";
    }    
  }
  else
  {
    GMTMode = " (manual)";
  }
  GMTOffsetStatusInfo = StringConcatenate("GMT Offset: ", DoubleToStr(ManualGMToffset, 1), GMTMode);
  GMTStartHour =  NormalizedHourParam(GMTStartHour);
  GMTStopHour  =  NormalizedHourParam(GMTStopHour);
  
  OneTimeInitialize = false; // clear the flag so this code base runs only one time
  return(0);
}


// Move this frequently used code block here to make the code easier to maintain
bool IsMyOrder()
{
//if (OrderSymbol() == Symbol() && (OrderMagicNumber() == MagicNumber || OrderMagicNumber() == MagicMigrate)) return(true);
//DM: removed MagicMigrate on 20100211
  if (OrderSymbol() == Symbol() && (OrderMagicNumber() == MagicNumber)) return(true);
  return(false);
}


// Close all Buy or Sell orders.  orderMode should be OP_BUY or OP_SELL
void CloseAllOrders(int orderMode)
{
  int OrderCount=0;
  int TicketArray[100];

// first, we retrieve all ticket IDs for existing orders to close out  
  for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
    {
      mode=OrderType();
      if (IsMyOrder())
	   {
        if ((mode==orderMode) || (mode==(orderMode+2)) || (mode==(orderMode+4)))
        { 
          TicketArray[OrderCount]=OrderTicket();
          OrderCount++;
	 	  }
      }
	 }
  }

// second, we close out all applicable orders in the array.  this two step method prevents problems closing out all orders successfully at once.
  for(cnt=0;cnt<OrderCount;cnt++)
  {
    if (OrderSelect(TicketArray[cnt], SELECT_BY_TICKET, MODE_TRADES))
    {
      if(GetTradeContext()) RefreshRates();
      if (orderMode==OP_BUY)
      {
        OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,myDigits),slippage,ArrowsColor);
      }
      if (orderMode==OP_SELL)
      {
        OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,myDigits),slippage,ArrowsColor);
      }
      if (mode == (orderMode+2) || mode == (orderMode+4))
      {
        OrderDelete(OrderTicket());
      }
	 }
  }

  PreviousOpenOrders[orderMode] = 0;
  CurrentOpenOrders[orderMode]  = 0;
  LastOrderOpenPrice[orderMode] = 0;
  CalculateLotArray(orderMode,0); // Recalculate lots now that the account balance has changed so the chart display is refreshed
}


void UpdateOrderStatus(bool init)
{
  CurrentOpenOrders[OP_BUY]=0;
  CurrentOpenOrders[OP_SELL]=0;
  MarketOpenOrders[OP_BUY]=0;
  MarketOpenOrders[OP_SELL]=0;
  int myOrderType;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
    {
      if (IsMyOrder())
      {				
        myOrderType = OrderType();
        if (myOrderType<=1) MarketOpenOrders[myOrderType]++;
        while (myOrderType > 1) myOrderType-=2; // Normalize all buy types to OP_BUY and all sell types to OP_SELL
        CurrentOpenOrders[myOrderType]++;
        if(LastOrderOpenTime[myOrderType]<OrderOpenTime())
        {
          LastOrderOpenTime[myOrderType]=OrderOpenTime();
          LastOrderOpenPrice[myOrderType]=OrderOpenPrice();
        }
      }
    }
  }
  if (init)
  {
    PreviousOpenOrders[OP_BUY]=CurrentOpenOrders[OP_BUY];
    PreviousOpenOrders[OP_SELL]=CurrentOpenOrders[OP_SELL];
  }
}


string ShowLotSizeSequence()
{
  // Determine Precision of LotSize
  int x=0;
  string result;
  if (MarketInfo(Symbol(), MODE_LOTSTEP)==0.1) x=1;
  if (MarketInfo(Symbol(), MODE_LOTSTEP)==0.01) x=2;
  if (TradeMicroLots) x=2;

  if (MaxTrades>0)
  {
    // iterate array
    result=StringConcatenate("\nBuy LotSizing: ",DoubleToStr(LotSizeArray[0,OP_BUY],x));
    for (int myCount=1;myCount<MaxTrades;myCount++) result = StringConcatenate(result, ", ", DoubleToStr(LotSizeArray[myCount,OP_BUY],x));
    result = StringConcatenate(result," @",DoubleToStr(ActualRiskPercentB,1),"% Max Potential DD");
    result=StringConcatenate(result,"\nSell  LotSizing: ",DoubleToStr(LotSizeArray[0,OP_SELL],x));
    for (myCount=1;myCount<MaxTrades;myCount++) result = StringConcatenate(result, ", ", DoubleToStr(LotSizeArray[myCount,OP_SELL],x));
    result = StringConcatenate(result," @",DoubleToStr(ActualRiskPercentS,1),"% Max Potential DD");
  }
  else
  {
    result=("\nEA will not open new orders since MaxTrades=0\nMonitoring existing trades until they can be closed out");
  }
  
  return(result);
}


// Called from the Init function, this populates from globals or causes initial calculation to occur
void ReadLotArray()
{
  bool BuyReadSuccess=true, SellReadSuccess=true;
  string gvBase = StringConcatenate("gvSPH_",Symbol(),DoubleToStr(MagicNumber,0),"_");
  string gvName;
  int gv_total = GlobalVariablesTotal(), StoredPos, a, b;

  UpdateOrderStatus(false);
  
  for (cnt=0;cnt<100;cnt++)
  {
    if (CurrentOpenOrders[OP_BUY]==0)  LotSizeArray[cnt,OP_BUY]=0;
    if (CurrentOpenOrders[OP_SELL]==0) LotSizeArray[cnt,OP_SELL]=0;
  }

  if (CurrentOpenOrders[OP_BUY]>0 || CurrentOpenOrders[OP_SELL]>0)
  {
    for (int count=0;count<gv_total;count++)
    {
      gvName = GlobalVariableName(count);
      if (StringFind(gvName, gvBase, 0) == 0) // Belongs to me
      {
        if (StringFind(gvName, "B_", StringLen(gvBase)-1) > 0 && CurrentOpenOrders[OP_BUY]>0) // BUY Lot Array Entry
        {
          a = StringFind(gvName, "_", StringLen(gvBase) + 1);
          b = StringFind(gvName, "_", a + 1);
          a += 1;
          StoredPos = StrToInteger(StringSubstr(gvName,a,b-a));
          LotSizeArray[StoredPos,OP_BUY] = GlobalVariableGet(gvName);
        } 
        if (StringFind(gvName, "S_", StringLen(gvBase)-1) > 0 && CurrentOpenOrders[OP_SELL]>0) // SELL Lot Array Entry
        {
          a = StringFind(gvName, "_", StringLen(gvBase) + 1);
          b = StringFind(gvName, "_", a + 1);
          a += 1;
          StoredPos = StrToInteger(StringSubstr(gvName,a,b-a));
          LotSizeArray[StoredPos,OP_SELL] = GlobalVariableGet(gvName);
        } 
      }
    }

    // Now verify arrays, if either is inconsistent, we will just recalculate that one
    for (count=0;count<MaxTrades;count++)
    {
      if (!(LotSizeArray[count,OP_BUY]>0)) BuyReadSuccess=false;
      if (!(LotSizeArray[count,OP_SELL]>0)) SellReadSuccess=false;
    }
    if (!(LotSizeArray[99,OP_BUY]>0)) BuyReadSuccess=false;
    if (!(LotSizeArray[99,OP_SELL]>0)) SellReadSuccess=false;
    
    if (!BuyReadSuccess) CalculateLotArray(OP_BUY,0);
    if (!SellReadSuccess) CalculateLotArray(OP_SELL,0);
  }
  else // No BUY or SELL orders opened
  {
    CalculateLotArray(OP_BUY,0);
    CalculateLotArray(OP_SELL,0);
  }

  // Calculate the maximum draw down potential per sequence here
  // This is the same code from the bottom of the CalculateLotArray function
  double MaxLossAmount = 0;
  for (cnt=0;cnt<MaxTrades;cnt++) MaxLossAmount += (StopLoss - cnt*Pips) * LotSizeArray[cnt,OP_BUY];
  ActualRiskPercentB = (MarketInfo(Symbol(), MODE_TICKVALUE) * MaxLossAmount * 100) / AccountBalance();
  MaxLossAmount = 0;
  for (cnt=0;cnt<MaxTrades;cnt++) MaxLossAmount += (StopLoss - cnt*Pips) * LotSizeArray[cnt,OP_SELL];
  ActualRiskPercentS = (MarketInfo(Symbol(), MODE_TICKVALUE) * MaxLossAmount * 100) / AccountBalance();
}


void WriteLotArray()
{
  string gvB = StringConcatenate("gvSPH_",Symbol(),DoubleToStr(MagicNumber,0),"_B_");
  string gvS = StringConcatenate("gvSPH_",Symbol(),DoubleToStr(MagicNumber,0),"_S_");
  string gvName;
  for (int count=0;count<MaxTrades;count++)
  {
    gvName = StringConcatenate(gvB,DoubleToStr(count,0),"_");
    GlobalVariableSet(gvName, LotSizeArray[count,OP_BUY]);
    gvName = StringConcatenate(gvS,DoubleToStr(count,0),"_");
    GlobalVariableSet(gvName, LotSizeArray[count,OP_SELL]);
  }
  gvName = StringConcatenate(gvB,DoubleToStr(99,0),"_");
  GlobalVariableSet(gvName, LotSizeArray[99,OP_BUY]);
  gvName = StringConcatenate(gvS,DoubleToStr(99,0),"_");
  GlobalVariableSet(gvName, LotSizeArray[99,OP_SELL]);
}


//*********************************************************************************************************************
//******************TOM - new routine to modify all trades in set to requested tp level********************************
//Routine modified by DM on 20100211 to avoid error 1's that showed up in backtesting
void ModifyTakeProfits(double newTP, int MagicNumber, int op)
{
   int cnt=0, err=0;
   bool result;
   int OrderCount=0;
   int TicketArray[100];

// first, we retrieve all ticket IDs for existing orders to modify  
   for(cnt = 0; cnt < OrdersTotal(); cnt++)
   {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
         mode=OrderType();
         if (IsMyOrder() && mode==op)
	      {
            TicketArray[OrderCount]=OrderTicket();
            OrderCount++;
         }
	   }
   }

// second, if there is more than 1 order, then we will modify orders.
   if (OrderCount>1)
   for(cnt=0;cnt<OrderCount;cnt++)
   {
      if (OrderSelect(TicketArray[cnt], SELECT_BY_TICKET, MODE_TRADES))
      {
         if(GetTradeContext()) RefreshRates();
         if(NormalizeDouble(OrderTakeProfit(),myDigits) != NormalizeDouble(newTP,myDigits))
		   {
  	         result=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), newTP, 0, Purple);
				if (result != TRUE) err = GetLastError();
			   if (err > 1) Print("LastError = (", err, "): ", ErrorDescription(err));
            else OrderPrint();
	  		}
      }
   }
}

//*********************************************************************************************************************
//*********************************************************************************************************************
//******************TOM - new routine for derermining the set's stop loss which would be with the level 1 order *******
//******************      I'm just looping through the set but you could probably just grab the oldest trade **********
double CalcStopLoss(int op)
  {
   int ticket;
   double HighestBuy, LowestSell;
   double HighestBuySL, LowestSellSL;
   double newSL;
//----
   HighestBuy = 0;
   LowestSell = 9999;
   HighestBuySL = 0;
   LowestSellSL = 0;
   newSL = 0;
 
   for(int i=0;i<OrdersTotal();i++)
     {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      if (op == OP_BUY && OrderType() == OP_BUY)
         {
            if (OrderOpenPrice() > HighestBuy)
            {
               HighestBuy = OrderOpenPrice();
               HighestBuySL = OrderStopLoss();
            }
         }
         
      if (op == OP_SELL && OrderType() == OP_SELL)
         {
            if (OrderOpenPrice() < LowestSell)
            {
               LowestSell = OrderOpenPrice();
               LowestSellSL = OrderStopLoss();
            }
         }
     }
     
  switch (op)
  {  
    case OP_BUY:
      if (HighestBuySL==0)
         newSL = BuyPrice-StopLoss*Point;
      else
         newSL = HighestBuySL;
      break; 	
    case OP_SELL:
      if (LowestSellSL==0)
         newSL = SellPrice+StopLoss*Point;
      else
         newSL = LowestSellSL;
      break; 	
    default: 
      break;
  }
     
 return (newSL);
}

//*********************************************************************************************************************
//*********************************************************************************************************************
//********** TOM - still on my to do list - plan to log DD info for each bar to plot in excel *************************
//**********       I want to overlay all the pairs to see if we have tendency for confluence of DD given **************
//**********       natural pair correlations - getting hit by an occasional wave (SL) should be expected **************
//**********       but want to try and avoid rogue waves where we get hit by multiple at same time ********************
//**********       I have not hooked this in as I'm still deciding what I want to log ********************************* 
void LogPerformance()
{
  int handle;
  handle=FileOpen(StringConcatenate(EAName, " Log ", Symbol(), ".txt"), FILE_CSV|FILE_READ|FILE_WRITE, ';');
  if(handle > 0)
    {
     FileSeek(handle, 0, SEEK_END);
     FileWrite(handle, Symbol(), TimeToStr(TimeCurrent()), AccountBalance(), AccountEquity());
     FileClose(handle);
    }
}

//*********************************************************************************************************************
//****************** Code added by David Heath to handle Black Out days
//*********************************************************************************************************************
bool BlackoutTime() //DM: Kept variables global in scope
{
   if (EnableBlackout)
   {
      StartBlackout = DayNumber(StartBlackoutMonth, StartBlackoutDay);
      StopBlackout = DayNumber(StopBlackoutMonth, StopBlackoutDay);
      
      if (StartBlackout <= StopBlackout && DayOfYear() >= StartBlackout && DayOfYear() < StopBlackout)
      {
         return (true);
      }
      
      if ((StartBlackout > StopBlackout && DayOfYear() >= StartBlackout) || (StartBlackout > StopBlackout && DayOfYear() < StopBlackout))
      {
         return (true);
      }
      
      
      else return (false);
      
   }      
   
   return (false);
}

int DayNumber(int month, int day) {
   
   int days = 0;
   switch(month)
   {
      case 1 : days = 0; break;    
      case 2 : days = 31; break;
      case 3 : days = 59; break;
      case 4 : days = 90; break;
      case 5 : days = 120; break;
      case 6 : days = 151; break;
      case 7 : days = 181; break;
      case 8 : days = 212; break;
      case 9 : days = 243; break;
      case 10: days = 273; break;
      case 11: days = 304; break;
      case 12: days = 334; break;
   }
   
   days = days + day;
   
   bool leapYear = false;
   
   if (MathMod(Year(), 4) == 0)
   {
      leapYear = true;
   }
   else if (MathMod(Year(), 400) == 0)
   {
      leapYear = true;
   }
   else if (MathMod(Year(), 100) == 0)
   {
      leapYear = false;
   }
   
   if (leapYear == true && month > 2) days++;
   
   return (days);
}


